/*
 ķ
   Program..: _DCMENU2.PRG                                    
   Author...: Roger J. Donnay                                 
   Notice...: (c) DONNAY Software Designs 1987-2002           
   Date.....: Oct  7, 2002                                    
                                                              
   Functions: dc_menu_bar(), dc_menuto(), dc_menu_p()         
              dc_at_prompt(), dc_menu_to(), dc_at_clear()     
              dc_menumain(), dc_alert(), dc_menureturn()      
              dc_menuname(), dc_menuaccel(), dc_guimenuto()   
 Ľ
*/

#include 'xbp.ch'
#include 'gra.ch'
#include "Common.ch"
#include "font.ch"
#include "appevent.ch"
#INCLUDE "dcmsg.CH"
#INCLUDE "dcdialog.ch"

#pragma Ansi2Oem(OFF)


#define  MAX_BUTTONS         7

#define  BUTTON_FONT         FONT_HELV_SMALL
#define  TEXT_FONT           FONT_TIMES_MEDIUM
#define  TEXT_COLOR          GRA_CLR_BLUE

#define cOLDCOLOR   aColors[1]
#define cBOXCOLOR   aColors[2]
#define cMENUCOLOR  aColors[3]
#define cHOTCOLOR   aColors[4]
#define cSELCOLOR   aColors[5]
#define cGRAYCOLOR  aColors[6]
#define cSAVECOLOR  aColors[7]


MEMVAR dCCOLOR

#include "inkey.ch"
#include "dccolor.ch"

STATIC aMenuPrompt := {{},{},{},{},{}}
STATIC cScreen := nil
STATIC lMenuScrn := nil
STATIC aMenuPush := nil
STATIC lParent := .f.
STATIC nReturn := 0

FUNCTION DC_Menu_P ( nStRow, nStCol, cTitle, cColors, cType, lBar, ;
                     lReturnVal, nStart, aPrompt, aBlocks, aRowCol, ;
                     aMessage, aMsgOptions, cExitKeys, lRestoreScreen, ;
                     lShadow, aMouseKeys, lSticky, aHelp, aAccess, ;
                     aReturns, lReMenu, cHeirArchy, aAccelKeys, ;
                     aMenuId, cMenuName )

LOCAL aReturn := DC_MenuPull( { nStRow, nStCol, cTitle, cColors, cType, ;
                      lBar, lReturnVal, cExitKeys, lRestoreScreen, ;
                      lShadow, lSticky, lReMenu, cHeirArchy, aMouseKeys, ;
                      aMsgOptions, aRowCol, aPrompt, nil, aBlocks, ;
                      aMessage, aHelp, aAccess, aReturns, aAccelKeys,;
                      aMenuId }, ;
                      @nStart, .f., cMenuName )

nStart := aReturn[2]
RETURN aReturn[1]

/* --------------------- */

FUNCTION DC_MenuPull ( aPull, nStart, lRightJust, cMenuId )

LOCAL aMenuP[66], aColors[7], nRow, nCol

#define nSTROW         aPull[1]
#define nSTCOL         aPull[2]
#define cTITLE         aPull[3]
#define cCOLORS        aPull[4]
#define cTYPE          aPull[5]
#define lBAR           aPull[6]
#define lRETURNVAL     aPull[7]
#define cEXITKEYS      aPull[8]
#define lRESTORESCREEN aPull[9]
#define lSHADOW        aPull[10]
#define lSTICKY        aPull[11]
#define lREMENU        aPull[12]
#define cHEIRARCHY     aPull[13]
#define aMOUSEKEYS     aPull[14]
#define aMSGOPTIONS    aPull[15]
#define aROWCOL        aPull[16]
#define aPROMPT        aPull[17]
#define aPROMPTBLOCK   aPull[18]
#define aBLOCKS        aPull[19]
#define aMESSAGE       aPull[20]
#define aHELP          aPull[21]
#define aACCESS        aPull[22]
#define aRETURNS       aPull[23]
#define aACCELKEYS     aPull[24]
#define aMENUID        aPull[25]

#define cMP_TEMP          aMenuP[1]
#define nMP_TEMPNUM       aMenuP[2]
#define nMP_ITEMLEN       aMenuP[3]
#define nMP_LASTITEM      aMenuP[4]
#define cMP_MENUSCRN      aMenuP[5]
#define cMP_KEY           aMenuP[6]
#define cMP_KEY2          aMenuP[7]
#define cMP_SCRN          aMenuP[8]
#define nMP_ITEMS         aMenuP[9]
#define nMP_MSGLEN        aMenuP[10]
#define nMP_HOTSTART      aMenuP[11]
#define cMP_SAVEMSG       aMenuP[12]
#define cMP_BUFFER        aMenuP[13]
#define nMP_INKEY         aMenuP[14]
#define cMP_SAVESCREEN    aMenuP[15]
#define cMP_TEMPSTR       aMenuP[16]
#define cMP_START         aMenuP[17]
#define lMP_MOUSEHIT      aMenuP[18]
#define nMP_SAVEROW       aMenuP[19]
#define nMP_SAVECOL       aMenuP[20]
#define lMP_MESSAGE       aMenuP[21]
#define nMP_MOUSTATUS     aMenuP[22]
#define nMP_STROW         aMenuP[23]
#define nMP_STCOL         aMenuP[24]
#define nMP_ENROW         aMenuP[25]
#define nMP_ENCOL         aMenuP[26]
#define nMP_X1            aMenuP[27]
#define nMP_X2            aMenuP[28]
#define nMP_Y1            aMenuP[29]
#define nMP_Y2            aMenuP[30]
#define lMP_MOUENTER      aMenuP[31]
#define lMP_MOUVISIBLE    aMenuP[32]
#define nMP_PASS          aMenuP[33]
#define nMP_ELEMENT       aMenuP[34]
#define cMP_SAVESTATIC    aMenuP[35]
#define lMP_REMENU        aMenuP[36]
#define lMP_REPAINT       aMenuP[37]
#define nMP_MSGNUM        aMenuP[38]
#define aMP_SUBMENU       aMenuP[39]
#define aMP_SUBBLOCK      aMenuP[40]
#define aMP_SUBPBLOCK     aMenuP[41]
#define aMP_SUBMSG        aMenuP[42]
#define aMP_SUBHELP       aMenuP[43]
#define aMP_SUBACCESS     aMenuP[44]
#define aMP_SUBRETURN     aMenuP[45]
#define aMP_SUBMENUID     aMenuP[46]
#define aMP_MSGLINES      aMenuP[47]
#define aMP_MSGOPT        aMenuP[48]
#define aMP_MENUITEMS     aMenuP[49]
#define aMP_HOTKEYS       aMenuP[50]
#define aMP_MENUBLOCKS    aMenuP[51]
#define aMP_SUBITEMS      aMenuP[52]
#define aMP_BLOCKITEMS    aMenuP[53]
#define aMP_MSGITEMS      aMenuP[54]
#define aMP_HELPITEMS     aMenuP[55]
#define aMP_ACCITEMS      aMenuP[56]
#define aMP_RETITEMS      aMenuP[57]
#define aMP_IDITEMS       aMenuP[58]
#define aMP_PBLOCKITEMS   aMenuP[59]
#define cMP_SAVESCRN2     aMenuP[60]
#define nMP_BOTTOMROW     aMenuP[61]
#define nMP_LEFTSHIFT     aMenuP[62]
#define lMP_GRAYED        aMenuP[63]
#define aMP_MSGSCRN       aMenuP[64]
#define aMP_MENUID        aMenuP[65]
#define cMP_CHILDID       aMenuP[66]

IF Valtype( aPull ) = 'C'
  aPull := DC_DO('DC_MenuCompile(DC_MenuLoad("'+aPull+'",,,"P"))')
ENDIF
IF Valtype(aPull)#'A' // .OR. Len(aPull)<23
  RETURN {'',0}
ENDIF
ASize(aPull,25)
lRightJust := IIF(Valtype(lRightJust)='L',lRightJust,.f.)
cMenuId    := IIF(Valtype(cMenuId)='C',cMenuId,'')

cMP_SAVESTATIC := cScreen

DO WHILE .t.

  cTYPE          := IIF(Valtype(cTYPE)='L',IIF(cTYPE,'A','B'),cTYPE)
  cTYPE          := IIF(Valtype(cTYPE)='C',UPPER(cTYPE),'C')
  nSTROW         := IIF(Valtype(nSTROW)='N',nSTROW,0)
  nSTCOL         := IIF(Valtype(nSTCOL)='N',nSTCOL,0)
  cTITLE         := IIF(Valtype(cTITLE)='C',cTITLE,'')
  cCOLORS        := IIF(Valtype(cCOLORS)='C',cCOLORS,'')
  lBAR           := IIF(Valtype(lBAR)='L',lBAR,.t.)
  lRETURNVAL     := IIF(Valtype(lRETURNVAL)='L',lRETURNVAL,.f.)
  lSTICKY        := IIF(Valtype(lSTICKY)='L',lSTICKY,.f.)
  lREMENU        := IIF(Valtype(lREMENU)='L',lREMENU,.f.)
  lRESTORESCREEN := IIF(Valtype(lRESTORESCREEN)='L',lRESTORESCREEN,.t.)
  cHEIRARCHY     := IIF(Valtype(cHEIRARCHY)='C',UPPER(cHEIRARCHY),'S')
  aPROMPT        := IIF(Valtype(aPROMPT)='A',aPROMPT,{})
  aPROMPTBLOCK   := IIF(Valtype(aPROMPTBLOCK)='A',aPROMPTBLOCK,{})
  aBLOCKS        := IIF(Valtype(aBLOCKS)='A',aBLOCKS,{})
  aROWCOL        := IIF(Valtype(aROWCOL)='A',aROWCOL,{})
  aHELP          := IIF(Valtype(aHELP)='A',aHELP,{})
  aACCESS        := IIF(Valtype(aACCESS)='A',aACCESS,{})
  aRETURNS       := IIF(Valtype(aRETURNS)='A',aRETURNS,{})
  aMENUID        := IIF(Valtype(aMENUID)='A',aMENUID,{})
  lSHADOW        := IIF(Valtype(lSHADOW)='L',lSHADOW,cTYPE='A')
  cTITLE         := IIF(Valtype(cTITLE)='C',ALLTRIM(cTITLE),'')

  IF cHEIRARCHY = 'M'
    IF lParent
      lParent := .f.
      aMenuPush := aPull
      cScreen := cMP_SAVESTATIC
      RETURN {'',0}
    ENDIF
    lParent := .t.
  ENDIF
  aMenuPush := nil
  IF !(LEFT(cTITLE,1)=='[') .AND. !EMPTY(cTITLE)
    cTITLE := '[ ' +AllTrim(cTITLE) + ' ]'
  ENDIF
  cEXITKEYS      := Chr(K_ESC) + IIF(Valtype(cEXITKEYS)='C',cEXITKEYS,'')
  ASize(aBLOCKS,Len(aPROMPT))
  ASize(aPROMPTBLOCK,Len(aPROMPT))
  ASize(aHELP,Len(aPROMPT))
  ASize(aACCESS,Len(aPROMPT))
  ASize(aRETURNS,Len(aPROMPT))
  ASize(aMENUID,Len(aPROMPT))
  aMP_MENUITEMS     := {}
  aMP_HOTKEYS       := {}
  aMP_MENUBLOCKS    := {}
  aMP_SUBITEMS      := {}
  aMP_BLOCKITEMS    := {}
  aMP_PBLOCKITEMS   := {}
  aMP_MSGITEMS      := {}
  aMP_HELPITEMS     := {}
  aMP_ACCITEMS      := {}
  aMP_RETITEMS      := {}
  aMP_IDITEMS       := {}
  lMP_REMENU        := lREMENU
  lMP_REPAINT       := .f.
  lMP_MOUVISIBLE    := DC_MOUVISIBLE()
  SET CURSOR off
  IF EMPTY(cScreen) .AND. !lSTICKY
    SAVE SCREEN TO cScreen
  ENDIF
  lMenuScrn := .t.
  lMP_MESSAGE := .f.
  IF Valtype( aMESSAGE ) = 'A'
    ASize(aMESSAGE,Len(aPROMPT))
    lMP_MESSAGE := .t.
  ENDIF
  IF Valtype(aMSGOPTIONS)='A'
    aMP_MSGOPT := ACLONE( aMSGOPTIONS )
  ELSE
    aMP_MSGOPT := { SET(_SET_MESSAGE),-1,0,0,0,0,0 }
  ENDIF
  ASize( aMP_MSGOPT, 12 )
  aMP_MSGOPT[1] := ;
     IIF(Valtype(aMP_MSGOPT[1])='N',aMP_MSGOPT[1],SET(_SET_MESSAGE))
  aMP_MSGOPT[2] := IIF(Valtype(aMP_MSGOPT[2])='N',aMP_MSGOPT[2],0)
  aMP_MSGOPT[3] := IIF(Valtype(aMP_MSGOPT[3])='N',aMP_MSGOPT[3],0)
  aMP_MSGOPT[4] := IIF(Valtype(aMP_MSGOPT[4])='N',aMP_MSGOPT[4],0)
  aMP_MSGOPT[5] := IIF(Valtype(aMP_MSGOPT[5])='N',aMP_MSGOPT[5],0)
  aMP_MSGOPT[6] := IIF(Valtype(aMP_MSGOPT[6])='N',aMP_MSGOPT[6],0)
  aMP_MSGOPT[7] := IIF(Valtype(aMP_MSGOPT[7])='N',aMP_MSGOPT[7],0)

  /* -- Set default colors -- */
  DO CASE
    CASE !DC_COLORMODE()
      cBOXCOLOR   := 'W/N,N/W,N,N,N/W'
      cMENUCOLOR  := 'W/N,N/W,N,N,N/W'
      cSELCOLOR   := 'N/W'
      cHOTCOLOR   := 'N/W'
      cGRAYCOLOR  := 'W/N,N/W,N,N,N/W'
    CASE Empty( cCOLORS )
      DC_CLRARR()
      cBOXCOLOR   := cC_POPMENF
      cMENUCOLOR  := Left( cC_POPMENI, At( ",", cC_POPMENI ) - 1 )
      cHOTCOLOR   := SubStr( cC_POPMENI, At( ",", cC_POPMENI ) + 1 )
      cGRAYCOLOR  := cC_POPGRAY
      cSELCOLOR   := cC_POPMENS
    OTHERWISE
      cMP_TEMPSTR := cCOLORS
      cBOXCOLOR   := Left( cMP_TEMPSTR, At( ",", cMP_TEMPSTR ) - 1 )
      cMP_TEMPSTR := Substr( cMP_TEMPSTR, At( ",", cMP_TEMPSTR ) + 1 )
      cMENUCOLOR  := Left( cMP_TEMPSTR, At( ",", cMP_TEMPSTR ) - 1 )
      cMP_TEMPSTR := Substr( cMP_TEMPSTR, At( ",", cMP_TEMPSTR ) + 1 )
      cHOTCOLOR   := Left( cMP_TEMPSTR, At( ",", cMP_TEMPSTR ) - 1 )
      cMP_TEMPSTR := Substr( cMP_TEMPSTR, At( ",", cMP_TEMPSTR ) + 1 )
      IF At( ',', cMP_TEMPSTR ) > 0
        cSELCOLOR := Left( cMP_TEMPSTR, At( ",", cMP_TEMPSTR ) - 1 )
      ELSE
        cSELCOLOR := cMP_TEMPSTR
      ENDIF
      cMP_TEMPSTR := SubStr( cMP_TEMPSTR, At( ",", cMP_TEMPSTR ) + 1 )
      cGRAYCOLOR  := cMP_TEMPSTR
  ENDCASE

  IF lMP_MESSAGE .AND. aMP_MSGOPT[3] = 2
    nMP_ITEMLEN := aMP_MSGOPT[5]
  ELSE
    nMP_ITEMLEN := 0
  ENDIF
  nMP_MSGLEN := 0
  nMP_LASTITEM := Len( aPROMPT )

  /* -- Find Top of menu -- */
  IF cTYPE == 'B'
    nMP_ITEMS := 0
    FOR nMP_TEMPNUM := 1 TO nMP_LASTITEM
      IF !EMPTY(aPROMPT[nMP_TEMPNUM])
        nMP_ITEMS++
      ENDIF
    NEXT
    nSTROW := nSTROW - nMP_ITEMS - 2
  ENDIF

  nMP_ITEMS := 0

  nMP_STROW := 24
  nMP_STCOL := 79
  nMP_ENROW := 0
  nMP_ENCOL := 0

  nMP_HOTSTART := IIF(cTYPE=='X',1,2)

  IF !(cTYPE=='X')
    nMP_BOTTOMROW := nSTROW + nMP_LASTITEM + 1
    IF lMP_MESSAGE .AND. !lMP_REPAINT .AND. aMP_MSGOPT[3] = 2
      nMP_BOTTOMROW += aMP_MSGOPT[4] + 1
    ENDIF
    IF nMP_BOTTOMROW > DC_MaxRow()
      nSTROW := nSTROW - (nMP_BOTTOMROW-DC_MaxRow())
    ENDIF
  ENDIF

  FOR nMP_TEMPNUM := 1 TO nMP_LASTITEM

     /* -- Get menu item -- */
    IF Valtype( aPROMPT[nMP_TEMPNUM] ) = 'A'
      ASize( aPROMPT[nMP_TEMPNUM], 9 )
      IF Valtype( aPROMPT[nMP_TEMPNUM,1] ) == 'C'
        cMP_TEMPSTR := aPROMPT[nMP_TEMPNUM,1]
      ELSEIF Valtype( aPROMPT[nMP_TEMPNUM,1] ) == 'B'
        cMP_TEMPSTR := Eval( aPROMPT[nMP_TEMPNUM,1] )
      ELSE
        cMP_TEMPSTR := ''
      ENDIF
      aMP_SUBMENU    := aPROMPT[nMP_TEMPNUM,2]
      aMP_SUBBLOCK   := aPROMPT[nMP_TEMPNUM,3]
      aMP_SUBMSG     := aPROMPT[nMP_TEMPNUM,4]
      aMP_SUBHELP    := aPROMPT[nMP_TEMPNUM,5]
      aMP_SUBACCESS  := aPROMPT[nMP_TEMPNUM,6]
      aMP_SUBRETURN  := aPROMPT[nMP_TEMPNUM,7]
      aMP_SUBPBLOCK  := aPROMPT[nMP_TEMPNUM,8]
      aMP_SUBMENUID  := aPROMPT[nMP_TEMPNUM,9]
    ELSE
      IF Valtype( aPROMPT[nMP_TEMPNUM] ) == 'C'
        cMP_TEMPSTR := aPROMPT[nMP_TEMPNUM]
      ELSEIF Valtype( aPROMPT[nMP_TEMPNUM] ) == 'B'
        cMP_TEMPSTR := Eval( aPROMPT[nMP_TEMPNUM] )
      ELSE
        cMP_TEMPSTR := ''
      ENDIF
      aMP_SUBMENU    := nil
      aMP_SUBBLOCK   := nil
      aMP_SUBMSG     := nil
      aMP_SUBHELP    := nil
      aMP_SUBACCESS  := nil
      aMP_SUBRETURN  := nil
      aMP_SUBPBLOCK  := nil
      aMP_SUBMENUID  := nil
    ENDIF
    IF EMPTY( cMP_TEMPSTR )
      LOOP
    ENDIF

    lMP_GRAYED := .f.
    IF Valtype( aPROMPTBLOCK[nMP_TEMPNUM] ) = 'B'
      lMP_GRAYED := !EVAL(aPROMPTBLOCK[nMP_TEMPNUM])
    ENDIF

    nMP_ITEMS++

     /* -- store position of hot-key letter, or gray item -- */
    DO CASE
      CASE LEFT(cMP_TEMPSTR,1)$'@*' .OR.lMP_GRAYED
        IF LEFT(cMP_TEMPSTR,1)='*'
          cMP_TEMPSTR := SUBSTR( cMP_TEMPSTR, nMP_HOTSTART )
        ENDIF
        AADD( aMP_HOTKEYS, 0 )
      CASE "~" $ cMP_TEMPSTR
        AADD( aMP_HOTKEYS, At( "~", cMP_TEMPSTR ) + nMP_HOTSTART - 1 )
      OTHERWISE
        AADD( aMP_HOTKEYS, Len(cMP_TEMPSTR) - Len(LTRIM(cMP_TEMPSTR)) + ;
              nMP_HOTSTART )
    ENDCASE

     /* -- Store menu item -- */
    AADD( aMP_MENUITEMS, StrTran( cMP_TEMPSTR,"~","") )
    AADD( aMP_SUBITEMS, aMP_SUBMENU )
    AADD( aMP_BLOCKITEMS, aMP_SUBBLOCK )
    AADD( aMP_MSGITEMS, aMP_SUBMSG )
    AADD( aMP_HELPITEMS, aMP_SUBHELP )
    AADD( aMP_ACCITEMS, aMP_SUBACCESS )
    AADD( aMP_RETITEMS, aMP_SUBRETURN )
    AADD( aMP_PBLOCKITEMS, aMP_SUBPBLOCK )
    AADD( aMP_IDITEMS, aMP_SUBMENUID )
    AADD( aMP_MENUBLOCKS, aBLOCKS[nMP_TEMPNUM] )

     /* -- Store length of longest menu item -- */
    nMP_ITEMLEN := Max( Len( aMP_MENUITEMS[ nMP_ITEMS ] ), nMP_ITEMLEN )

    IF Len( aROWCOL ) < nMP_ITEMS
      AADD( aROWCOL, { nSTROW+nMP_ITEMS, nSTCOL+1 })
    ENDIF

  NEXT
  nMP_LEFTSHIFT := 0
  IF !(cTYPE=='X')
    nMP_STROW := nSTROW + 1
    nMP_ENROW := nSTROW + nMP_ITEMS
    IF lRightJust
      nSTCOL -= nMP_ITEMLEN
      IF nSTCOL < 2
        nSTCOL := 2
        lRightJust := .f.
      ENDIF
      FOR nMP_TEMPNUM := 1 TO Len(aROWCOL)
        aROWCOL[nMP_TEMPNUM,2] := nSTCOL+1
      NEXT
    ELSE
      nMP_LEFTSHIFT := nSTCOL + nMP_ITEMLEN + 3 - DC_MaxCol()
      IF nMP_LEFTSHIFT > 0
        lRightJust := .t.
        nSTCOL -= nMP_LEFTSHIFT
        FOR nMP_TEMPNUM := 1 TO Len(aROWCOL)
          aROWCOL[nMP_TEMPNUM,2] -= nMP_LEFTSHIFT
        NEXT
      ENDIF
    ENDIF
    nMP_STCOL := nSTCOL + 1
    nMP_ENCOL := nSTCOL + nMP_ITEMLEN
  ENDIF

  nMP_LASTITEM := nMP_ITEMS

  /* -- See if title is longer than longest menu item -- */
  nMP_ITEMLEN := Max( Len( cTITLE ), nMP_ITEMLEN )

  nMP_X1 := nSTROW
  nMP_Y1 := nSTCOL - IIF(DC_ALTSHADOW()=2, 0, 2 )
  nMP_X2 := nSTROW + nMP_LASTITEM + 2
  nMP_Y2 := nSTCOL + nMP_ITEMLEN + IIF(DC_ALTSHADOW()=2, 5, 3 )

  cMP_SCRN := SaveScreen( nMP_X1, nMP_Y1, nMP_X2, nMP_Y2 )

  DO WHILE .t.

    DC_DispBegin()

    cOLDCOLOR := setcolor()
    /* -- Draw menu frame -- */
    IF cTYPE$'ABC'
      DC_COLOR( cBOXCOLOR )
      @ nSTROW, nSTCOL TO nSTROW + nMP_LASTITEM + 1, nSTCOL + nMP_ITEMLEN + 3
    ENDIF

    /* -- Draw Shadow -- */
    IF lSHADOW .AND. DC_AltShadow() > 0
      IF DC_AltShadow() = 2
        cMP_BUFFER := SaveScreen( nSTROW+1, nSTCOL+nMP_ITEMLEN+4, ;
                                  nSTROW+nMP_LASTITEM+2, nSTCOL+nMP_ITEMLEN+5 )
        RestScreen( nSTROW+1, nSTCOL+nMP_ITEMLEN+4, ;
                    nSTROW+nMP_LASTITEM+2, nSTCOL+nMP_ITEMLEN+5,;
                    cMP_BUFFER )
        cMP_BUFFER := SaveScreen( nSTROW + nMP_LASTITEM + 2, ;
                                  nSTCOL+2, nSTROW + nMP_LASTITEM + 2,;
                                  nSTCOL + nMP_ITEMLEN + 3 )
        RestScreen( nSTROW + nMP_LASTITEM + 2, nSTCOL+2, ;
                    nSTROW + nMP_LASTITEM + 2, nSTCOL + nMP_ITEMLEN + 3,;
                    cMP_BUFFER )
      ELSE
        cMP_BUFFER := SaveScreen( nSTROW + 1, nSTCOL - 2, ;
                                  nSTROW + nMP_LASTITEM + 2, nSTCOL - 1 )
        RestScreen( nSTROW + 1, nSTCOL - 2, nSTROW + nMP_LASTITEM + 2, ;
                    nSTCOL - 1, cMP_BUFFER )
        cMP_BUFFER := SaveScreen( nSTROW + nMP_LASTITEM + 2, nSTCOL, ;
                                  nSTROW + nMP_LASTITEM + 2,;
                                  nSTCOL + nMP_ITEMLEN + 1 )
        RestScreen( nSTROW + nMP_LASTITEM + 2, nSTCOL, ;
                    nSTROW + nMP_LASTITEM + 2, nSTCOL + nMP_ITEMLEN + 1,;
                    cMP_BUFFER )
      ENDIF
    ENDIF

    /* -- Draw Title -- */
    IF !Empty( cTITLE ) .AND. !(cTYPE ='X')
      @ nSTROW + IIF( cTYPE == 'A', nMP_LASTITEM+1, 0 ), ;
        ( nSTCOL+2+(nMP_ITEMLEN/2) ) - ( Len(cTITLE)/2 ) SAY cTITLE
    ENDIF

    IF lMP_MESSAGE
      IF !lMP_REPAINT .AND. aMP_MSGOPT[3] = 2
        aMP_MSGOPT[6] := nMP_X2 + aMP_MSGOPT[4]
        aMP_MSGOPT[4] := nMP_X2
        aMP_MSGOPT[5] := nSTCOL
        aMP_MSGOPT[7] := nMP_Y2
      ENDIF
      IF aMP_MSGOPT[3] > 0
        cMP_SAVEMSG := SaveScreen( aMP_MSGOPT[4], aMP_MSGOPT[5]-2, ;
                                   aMP_MSGOPT[6]+2, aMP_MSGOPT[7]+2 )
      ENDIF
    ENDIF

    IF !lMP_REPAINT .AND. lMP_MESSAGE .AND. aMP_MSGOPT[3]=0
      FOR nMP_TEMPNUM := 1 TO nMP_LASTITEM
        /* -- Store length of longest message item -- */
        IF Valtype( aMESSAGE[nMP_ITEMS] ) = 'C'
          nMP_MSGLEN := Max( Len( aMESSAGE[ nMP_TEMPNUM ] ), nMP_MSGLEN )
        ENDIF
      NEXT
    ENDIF

    IF aMP_MSGOPT[7] > aMP_MSGOPT[2] .AND. aMP_MSGOPT[2] >= 0
      nMP_MSGLEN := aMP_MSGOPT[7]-aMP_MSGOPT[2]+1
    ENDIF

    FOR nMP_TEMPNUM := 1 TO nMP_LASTITEM

      /* -- Pad menu items to longest item's length -- */
      IF !(cTYPE=='X')
        cMP_TEMPSTR := aMP_MENUITEMS[ nMP_TEMPNUM ]
        IF LEFT(cMP_TEMPSTR,1) = '@'
          @ nSTROW + nMP_TEMPNUM, nSTCOL TO ;
            nSTROW + nMP_TEMPNUM, nSTCOL + nMP_ITEMLEN + 3
          @ nSTROW + nMP_TEMPNUM, nSTCOL SAY ''
          @ nSTROW + nMP_TEMPNUM, nSTCOL + nMP_ITEMLEN + 3 SAY ''
          cMP_TEMPSTR := SUBSTR( cMP_TEMPSTR,2 )
          IF !EMPTY(cMP_TEMPSTR)
            @ nSTROW + nMP_TEMPNUM, ( nSTCOL + 1 + ( nMP_ITEMLEN / 2) ) ;
                 - ( len( cMP_TEMPSTR ) / 2 ) SAY cMP_TEMPSTR
          ENDIF
        ELSE
          IF !lMP_REPAINT
            aMP_MENUITEMS[ nMP_TEMPNUM ] := ;
               ' ' + Pad( cMP_TEMPSTR, nMP_ITEMLEN + 1 )
            IF Valtype(aMP_SUBITEMS[nMP_TEMPNUM])='A'
              aMP_MENUITEMS[ nMP_TEMPNUM ] := ;
                SubStr(aMP_MENUITEMS[nMP_TEMPNUM],1,;
                      Len(aMP_MENUITEMS[nMP_TEMPNUM])-1) + CHR(16)
            ENDIF
          ENDIF
          DevPos( aROWCOL[nMP_TEMPNUM,1], aROWCOL[nMP_TEMPNUM,2] )
          DevOut( aMP_MENUITEMS[ nMP_TEMPNUM ], ;
                  IIF( aMP_HOTKEYS[ nMP_TEMPNUM ] = 0, cGRAYCOLOR, cMENUCOLOR ) )
        ENDIF
      ENDIF

       /* -- Hilite Hot-keys -- */
      IF aMP_HOTKEYS[ nMP_TEMPNUM ] > 0
        DevPos( aROWCOL[nMP_TEMPNUM,1], aROWCOL[nMP_TEMPNUM,2] + ;
                aMP_HOTKEYS[ nMP_TEMPNUM ]-1 )
        DevOut( Substr( aMP_MENUITEMS[ nMP_TEMPNUM ], ;
                        aMP_HOTKEYS[ nMP_TEMPNUM ], 1 ), cHOTCOLOR )
      ENDIF

       /* -- Pad message items to longest item's length -- */
      IF !lMP_REPAINT .AND. lMP_MESSAGE .AND. aMP_MSGOPT[3]=0 .AND. ;
         Valtype( aMESSAGE[nMP_ITEMS] ) = 'C'
        aMESSAGE[ nMP_TEMPNUM] := PADC( aMESSAGE[ nMP_TEMPNUM ], nMP_MSGLEN )
      ENDIF

    NEXT

    DC_DispEnd()

    cMP_START := ''
    nMP_INKEY := K_DOWN
    DO CASE
      CASE Valtype( nStart ) = 'C'
        cMP_START := nStart
        nMP_ELEMENT := 1
      CASE Valtype( nStart ) = 'N'
        nMP_ELEMENT := IIF(nStart<=nMP_LASTITEM .AND. nStart>0,nStart,1)
      CASE lMP_REPAINT
      OTHERWISE
        nMP_ELEMENT := 1
    ENDCASE
    IF !EMPTY(cMP_START)
      FOR nMP_TEMPNUM := 1 TO nMP_LASTITEM
        IF Upper(cMP_START) == Upper( Substr( aMP_MENUITEMS[ nMP_TEMPNUM ],;
                         aMP_HOTKEYS[ nMP_TEMPNUM ], 1 ) )
          nMP_ELEMENT := nMP_TEMPNUM
          EXIT
        ENDIF
      NEXT
    ELSEIF !Empty(cMenuID) .AND. ;
       !Empty(cMP_CHILDID:=DC_DO('DC_MenuID("'+cMenuID+'")',,.f.,''))
      FOR nMP_TEMPNUM := 1 TO nMP_LASTITEM
        IF cMP_CHILDID == aMENUID[ nMP_TEMPNUM ]
          nMP_ELEMENT := nMP_TEMPNUM
          EXIT
        ENDIF
      NEXT
    ENDIF
    lMP_MOUSEHIT := .f.
    DC_InkeyMGet( @nRow, @nCol )
    nMP_MSGNUM := 0

    DO WHILE .t.

      nMP_PASS := 1
      DO WHILE aMP_HOTKEYS[ nMP_ELEMENT ] = 0
        IF nMP_INKEY=K_DOWN .OR. nMP_INKEY=50
          nMP_ELEMENT++
          IF nMP_ELEMENT > nMP_LASTITEM
            nMP_ELEMENT := 1
          ENDIF
        ELSE
          nMP_ELEMENT--
          IF nMP_ELEMENT < 1
            nMP_ELEMENT := nMP_LASTITEM
          ENDIF
        ENDIF
        nMP_PASS++
        IF nMP_PASS >= Len(aMP_HOTKEYS)
          nMP_ELEMENT := 1
          EXIT
        ENDIF
      ENDDO
      IF lBAR
        /* -- Display select bar over selected menu item -- */
        DC_COLOR( cSELCOLOR, .t. )
        DevPos( aROWCOL[nMP_ELEMENT,1], aROWCOL[nMP_ELEMENT,2] )
        DevOut( aMP_MENUITEMS[ nMP_ELEMENT ] )
      ENDIF
      IF lMP_MESSAGE .AND. nMP_MSGNUM#nMP_ELEMENT
        aMP_MSGSCRN := _DCMenuMsg( nMP_ELEMENT, aMP_MSGOPT, aColors, ;
                       aMESSAGE, aHELP, .f., lSHADOW )
        nMP_MSGNUM :=nMP_ELEMENT
      ENDIF
      SET CURSOR OFF
      BEGIN SEQUENCE
      cMP_KEY      := ''
      cMP_KEY2     := ''
      lMP_MOUENTER := .f.
      nMP_SAVEROW  := nRow
      nMP_SAVECOL  := nCol
      cSAVECOLOR   := SetColor(cOLDCOLOR)
      IF nMP_INKEY # K_ENTER
        nMP_INKEY  := DC_INKEY(,0,@nRow,@nCol,,.t.,,,,aHELP[nMP_ELEMENT])
      ENDIF
      IF lMP_MESSAGE .AND. Valtype(aMP_MSGSCRN)='A' .AND. ;
         aMP_MSGSCRN[3]=aMP_MSGSCRN[1] .AND. DC_MouButton()=0 .AND. ;
         lMenuScrn
          RestScreen( aMP_MSGSCRN[1],aMP_MSGSCRN[2],aMP_MSGSCRN[3],;
                      aMP_MSGSCRN[4],aMP_MSGSCRN[5] )
      ENDIF
      SetColor(cSAVECOLOR)
      lMP_MOUSEHIT := .f.
      IF nMP_INKEY <= -101
        IF (nRow < nMP_STROW-1 .OR. nRow > nMP_ENROW+1 ;
            .OR. nCol < nMP_STCOL-1 .OR. nCol > nMP_ENCOL+3 ) .AND. ;
            !EMPTY(DC_MOUSEKEY(aMOUSEKEYS,,,nRow,nCol))
          BREAK
        ENDIF
        IF aMP_MSGOPT[3] > 0 .AND. nRow >= aMP_MSGOPT[4] .AND. ;
           nRow <= aMP_MSGOPT[6] .AND. nCol >= aMP_MSGOPT[5] .AND. ;
           nCol <= aMP_MSGOPT[7]
          DC_PutKey( K_F1 )
          BREAK
        ENDIF
        IF nMP_SAVEROW#nRow .OR. nMP_SAVECOL#nCol .OR. nMP_INKEY=-104
          DO CASE
            CASE cTYPE#'X' .AND. (nRow < nMP_STROW-1 .OR. nRow > nMP_ENROW+1 ;
                 .OR. nCol < nMP_STCOL-1 .OR. nCol > nMP_ENCOL+3 ) ;
                 .AND. nMP_INKEY#-104
              nMP_INKEY := K_ESC
              nMP_ELEMENT := 0
              BREAK
            OTHERWISE
              FOR nMP_TEMPNUM := 1 TO nMP_LASTITEM
                IF nRow = aROWCOL[nMP_TEMPNUM,1] .AND. ;
                   nCol >= aROWCOL[nMP_TEMPNUM,2] ;
                  .AND. nCol <= aROWCOL[nMP_TEMPNUM,2]+ ;
                  Len(aMP_MENUITEMS[nMP_TEMPNUM])
                  IF nMP_INKEY = -104 .OR. ;
                     Valtype(aMP_SUBITEMS[nMP_TEMPNUM])='A'
                    DC_INKEYRELE(0)
                    lMP_MOUENTER := .t.
                  ELSE
                    lMP_MOUSEHIT := .t.
                    nMP_MSGNUM := 0
                  ENDIF
                  BREAK
                 ENDIF
               NEXT
           ENDCASE
         ENDIF
      ENDIF
      END SEQUENCE
      IF lBAR .AND. nMP_ELEMENT > 0 .AND. (nRow#nMP_SAVEROW .OR. ;
         nCol#nMP_SAVECOL .OR. nMP_INKEY>-100 .OR. lMP_MOUENTER )
         /* -- Display selected menu item -- */
        DevPos( aROWCOL[nMP_ELEMENT,1], aROWCOL[nMP_ELEMENT,2] )
        DevOut( aMP_MENUITEMS[ nMP_ELEMENT ], cMENUCOLOR )
        DevPos( aROWCOL[nMP_ELEMENT,1], aROWCOL[nMP_ELEMENT,2] + ;
                aMP_HOTKEYS[ nMP_ELEMENT ]-1 )
        DevOut( Substr( aMP_MENUITEMS[ nMP_ELEMENT ], ;
                        aMP_HOTKEYS[ nMP_ELEMENT ], 1 ), cHOTCOLOR )
      ENDIF
      IF lMP_MOUENTER
        nMP_ELEMENT := nMP_TEMPNUM
        nMP_INKEY := K_ENTER
      ELSEIF lMP_MOUSEHIT
        nMP_ELEMENT := nMP_TEMPNUM
        LOOP
      ENDIF

      DO CASE

        CASE nMP_INKEY = DC_DO('DC_MenuIDKey()',,.f.,-500)
          DC_DO('DC_MenuID("'+cMenuID+'","'+aMENUID[nMP_ELEMENT]+'")',,.f.,'')
          LOOP

         /* -- Exit Keys -- */
        CASE CHR(nMP_INKEY) $ cEXITKEYS
          cMP_KEY := CHR(nMP_INKEY)
          nMP_ELEMENT := 0
          lMP_REMENU := .f.
          EXIT

         /* -- Function Keys -- */
        CASE nMP_INKEY < 0 .AND. nMP_INKEY > -100
          cMP_KEY := '*'
          nReturn := nMP_INKEY
          EXIT

         /* -- Left Arrow -- */
        CASE (nMP_INKEY==K_LEFT .OR. nMP_INKEY==K_BS) .AND. cTYPE#'X'
          cMP_KEY := "<"
          EXIT

         /* -- Right Arrow -- */
        CASE nMP_INKEY == K_RIGHT .AND. cTYPE#'X'
          cMP_KEY := ">"
          EXIT

      ENDCASE

       /* -- Only if menu-bar is used -- */
      IF lBAR

        DO CASE


           /* -- Enter Key -- */
          CASE nMP_INKEY == K_ENTER
            IF lBAR
              IF lRETURNVAL
                cMP_KEY := CHR( nMP_ELEMENT )
              ELSE
                cMP_KEY := ;
                 Upper( Substr( aMP_MENUITEMS[ nMP_ELEMENT ], ;
                 aMP_HOTKEYS[ nMP_ELEMENT ], 1 ) )
              ENDIF
              IF lMP_MESSAGE .AND. nMP_MSGNUM#nMP_ELEMENT
                aMP_MSGSCRN := _DCMenuMsg( nMP_ELEMENT, aMP_MSGOPT, aColors, ;
                               aMESSAGE, aHELP, .f., lSHADOW )
                nMP_MSGNUM := nMP_ELEMENT
              ENDIF
              aACCESS[nMP_ELEMENT] := ;
               IIF(Valtype(aACCESS[nMP_ELEMENT])='C',aACCESS[nMP_ELEMENT],'')
              IF !DC_DO('DC_UserAccess("'+aACCESS[nMP_ELEMENT]+'")',,.f.,.t.)
              ELSEIF Valtype(aMP_MENUBLOCKS[nMP_ELEMENT])='B'
                nReturn := aRETURNS[nMP_ELEMENT]
                IF !EMPTY(cScreen) .AND. !lSTICKY
                  DC_RestScreen(cScreen)
                ENDIF
                IF lSTICKY
                  SAVE SCREEN TO cMP_SAVESCRN2
                ELSEIF lRESTORESCREEN
                  cMP_SAVESCRN2 := SaveScreen( nMP_X1, nMP_Y1, nMP_X2, nMP_Y2 )
                ENDIF
                BEGIN SEQUENCE
                Eval( aMP_MENUBLOCKS[nMP_ELEMENT] )
                END SEQUENCE
                IF lSTICKY
                  REST SCREEN FROM cMP_SAVESCRN2
                ELSEIF lRESTORESCREEN .AND. lMenuScrn .AND. !lMP_REMENU
                  RestScreen( nMP_X1, nMP_Y1, nMP_X2, nMP_Y2, cMP_SAVESCRN2 )
                ELSE
                  SAVE SCREEN TO cScreen
                ENDIF
                DC_InkeyRele(0)
                nMP_INKEY := 0
                IF !lSTICKY
                  EXIT
                ENDIF
              ELSEIF Valtype(aMP_SUBITEMS[nMP_ELEMENT])='A'
                nMP_TEMPNUM := (nMP_Y2-nMP_Y1-5) - ;
                   Len(TRIM(StrTran(aMP_MENUITEMS[nMP_ELEMENT],CHR(16),' ')))
                IF lRightJust
                  DevPos(aROWCOL[nMP_ELEMENT,1],aROWCOL[nMP_ELEMENT,2])
                  DevOut('<',cMENUCOLOR)
                ELSEIF nMP_TEMPNUM>0
                  DevPos(aROWCOL[nMP_ELEMENT,1],aROWCOL[nMP_ELEMENT,2] + 1 + ;
                    Len(TRIM(StrTran(aMP_MENUITEMS[nMP_ELEMENT],CHR(16),' '))))
                  DevOut(REPL('-',nMP_TEMPNUM)+'>',cMENUCOLOR )
                ENDIF
                cMP_KEY2 := ;
                  DC_MenuPull( { nMP_X1+nMP_ELEMENT, ;
                          nMP_Y2-IIF(lRightJust,nMP_ITEMLEN+6,0),;
                          '', cCOLORS, 'A', ;
                          lBAR, lRETURNVAL, cEXITKEYS, lRESTORESCREEN, ;
                          .f., lSTICKY, lREMENU, 'S', aMOUSEKEYS,;
                          aMSGOPTIONS, nil, ;
                          aMP_SUBITEMS[nMP_ELEMENT], ;
                          aMP_PBLOCKITEMS[nMP_ELEMENT], ;
                          aMP_BLOCKITEMS[nMP_ELEMENT], ;
                          aMP_MSGITEMS[nMP_ELEMENT], ;
                          aMP_HELPITEMS[nMP_ELEMENT], ;
                          aMP_ACCITEMS[nMP_ELEMENT], ;
                          aMP_RETITEMS[nMP_ELEMENT], ;
                          aACCELKEYS,;
                          aMP_IDITEMS[nMP_ELEMENT] },, ;
                          lRightJust, ;
                          aMENUID[nMP_ELEMENT] )[1]

                IF !EMPTY(cMP_KEY2)
                  EXIT
                ENDIF
              ELSE
                nReturn := aRETURNS[nMP_ELEMENT]
                EXIT
              ENDIF
              nMP_INKEY := 0
            ENDIF

           /* -- Up Arrow -- */
          CASE nMP_INKEY == K_UP .OR. nMP_INKEY == K_LEFT
            IF nMP_ELEMENT == 1
              nMP_ELEMENT := nMP_LASTITEM
            ELSE
              nMP_ELEMENT--
            ENDIF
            cMP_KEY := 'x'

           /* -- Down Arrow -- */
          CASE nMP_INKEY == K_DOWN .OR. nMP_INKEY == K_RIGHT
            IF nMP_ELEMENT == nMP_LASTITEM
              nMP_ELEMENT := 1
            ELSE
              nMP_ELEMENT++
            ENDIF
            cMP_KEY := 'x'

           /* -- Home Key -- */
          CASE nMP_INKEY == K_HOME
            nMP_ELEMENT := 1
            cMP_KEY := 'x'

           /* -- End Key -- */
          CASE nMP_INKEY == K_END
            nMP_ELEMENT := nMP_LASTITEM
            cMP_KEY := 'x'

           /* -- Accelerator Key was hit -- */
          CASE DC_MenuAccel(aACCELKEYS,nMP_INKEY)

        ENDCASE
      ENDIF

       /* -- Check for valid hot-key pressed -- */
      IF cMP_KEY==''
        cMP_KEY := Upper( DC_ChrInkey( nMP_INKEY ) )
        FOR nMP_TEMPNUM := 1 TO nMP_LASTITEM
          IF cMP_KEY == Upper( Substr( aMP_MENUITEMS[ nMP_TEMPNUM ],;
                     aMP_HOTKEYS[ nMP_TEMPNUM ], 1 ) )
            nMP_ELEMENT := nMP_TEMPNUM
            cMP_KEY := ''
            nMP_INKEY := K_ENTER
            EXIT
          ENDIF
        NEXT
        IF nMP_TEMPNUM > nMP_LASTITEM
          cMP_KEY := ''
        ENDIF
      ELSE
        IF nMP_INKEY = K_ENTER
          nMP_INKEY := 0
        ENDIF
        cMP_KEY := ''
      ENDIF

      IF !( cMP_KEY == '' )
        EXIT
      ENDIF

    ENDDO

    IF !lMP_REMENU .OR. !Empty(aMenuPush)
      EXIT
    ENDIF

    lMP_REPAINT := .t.
    nMP_INKEY := 0
    cMP_START := ''

  ENDDO

  IF Empty(aMenuPush) .OR. Len(aMenuPush)#23
    IF cHEIRARCHY='M'
      lParent := .f.
    ENDIF
    EXIT
  ENDIF
  aPull := aMenuPush
  aMenuPush := nil
  lParent := .f.

ENDDO

DC_COLOR( cOLDCOLOR )
cScreen := cMP_SAVESTATIC
IF cTYPE#'X' .AND. lRESTORESCREEN
  IF lMenuScrn
    IF !EMPTY(cMP_SAVEMSG)
      RestScreen( aMP_MSGOPT[4], aMP_MSGOPT[5]-2, aMP_MSGOPT[6]+2, ;
                  aMP_MSGOPT[7]+2, cMP_SAVEMSG )
    ENDIF
    RestScreen( nMP_X1, nMP_Y1, nMP_X2, nMP_Y2, cMP_SCRN )
  ENDIF
ELSEIF lBAR .AND. cMP_KEY#CHR(K_ESC)
   /* -- Display select bar over selected menu item -- */
  DC_COLOR( cSELCOLOR, .t. )
  DevPos( aROWCOL[nMP_ELEMENT,1], aROWCOL[nMP_ELEMENT,2] )
  DevOut( aMP_MENUITEMS[ nMP_ELEMENT ] )
ENDIF
SET CURSOR ON
IF lMP_MOUVISIBLE
  DC_MOUSHOW()
ENDIF
IF cMP_KEY = CHR(K_ESC) .OR. nMP_ELEMENT=0 .OR. ;
  ( aMP_HOTKEYS[nMP_ELEMENT]=0 .AND. !(cMP_KEY$'<>') )
  RETURN { '', 0 }
ENDIF
RETURN { cMP_KEY+cMP_KEY2, nMP_ELEMENT }

/* ----------------- */

STATIC FUNCTION ;
 _DCMenuMsg ( nElement, aMessageOpt, aColors, aMessage, aHelp, lMain, lShadow )

LOCAL aMsgLines, i, cBuffer, aMsgOpt := AClone(aMessageOpt), aMsgScrn

IF !Empty( aMessage[nElement] )
 IF lMain
    IF aMsgOpt[8]=2
      aMsgOpt[11] := aMsgOpt[11]+aMsgOpt[9]
      aMsgOpt[12] := aMsgOpt[12]+aMsgOpt[10]
      aMsgOpt[9]  := aMsgOpt[11]-aMsgOpt[9]
      aMsgOpt[10] := aMsgOpt[12]-aMsgOpt[10]
    ENDIF
    aMsgOpt[1] := aMsgOpt[9]
    aMsgOpt[2] := aMsgOpt[10]
    aMsgOpt[3] := aMsgOpt[8]
    aMsgOpt[4] := aMsgOpt[9]
    aMsgOpt[5] := aMsgOpt[10]
    aMsgOpt[6] := aMsgOpt[11]
    aMsgOpt[7] := aMsgOpt[12]
  ENDIF
  DC_DispBegin()
  IF aMsgOpt[3] > 0  // boxed message
    SetColor( cBOXCOLOR )
    IF aMsgOpt[7] > DC_MaxCol()
      i := aMsgOpt[7]-DC_MaxCol()
      aMsgOpt[7] -= i
      aMsgOpt[5] -= i
    ENDIF
    aMsgScrn := ;
      { aMsgOpt[4], aMsgOpt[5]-2, aMsgOpt[6]+1, aMsgOpt[7]+2,;
        SaveScreen( aMsgOpt[4], aMsgOpt[5]-2, aMsgOpt[6]+1, aMsgOpt[7]+2) }
    @ aMsgOpt[4], aMsgOpt[5] TO aMsgOpt[6], aMsgOpt[7]
    @ aMsgOpt[4]+1, aMsgOpt[5]+1 CLEAR TO aMsgOpt[6]-1, aMsgOpt[7]-1
    IF lShadow .AND. DC_AltShadow() > 0
      IF DC_AltShadow() = 2
        cBuffer := SaveScreen( aMsgOpt[4]+1, aMsgOpt[7]+1, ;
                               aMsgOpt[6]+1, aMsgOpt[7]+2 )
        RestScreen( aMsgOpt[4]+1, aMsgOpt[7]+1, ;
                    aMsgOpt[6]+1, aMsgOpt[7]+2,;
                    cBuffer  )
        cBuffer := SaveScreen( aMsgOpt[6]+1, aMsgOpt[5]+2, ;
                               aMsgOpt[6]+1, aMsgOpt[7]+2 )
        RestScreen( aMsgOpt[6]+1, aMsgOpt[5]+2, ;
                    aMsgOpt[6]+1, aMsgOpt[7]+2,;
                    cBuffer )
      ELSE
        cBuffer := SaveScreen( aMsgOpt[4]+1, aMsgOpt[5]-2, ;
                               aMsgOpt[6]+1, aMsgOpt[5]-1 )
        RestScreen( aMsgOpt[4]+1, aMsgOpt[5]-2, ;
                    aMsgOpt[6]+1, aMsgOpt[5]-1, ;
                    cBuffer )
        cBuffer := SaveScreen( aMsgOpt[6]+1, aMsgOpt[5]-2, ;
                               aMsgOpt[6]+1, aMsgOpt[7]-2 )
        RestScreen( aMsgOpt[6]+1, aMsgOpt[5]-2, ;
                    aMsgOpt[6]+1, aMsgOpt[7]-2, ;
                    cBuffer )
      ENDIF
    ENDIF
    SetColor( cMENUCOLOR )
    @ aMsgOpt[4]+1, aMsgOpt[5]+1 CLEAR TO aMsgOpt[6]-1, aMsgOpt[7]-1
    aMsgLines := DC_StrWrap( aMessage[nElement], aMsgOpt[7]-aMsgOpt[5]-3 )
    ASize( aMsgLines, MIN(Len(aMsgLines), aMsgOpt[6]-aMsgOpt[4]-1 ) )
    FOR i := 1 TO Len(aMsgLines)
      @ aMsgOpt[4]+i, aMsgOpt[5]+2 SAY TRIM(aMsgLines[i])
    NEXT
    SetColor( cBOXCOLOR )
    IF !lMain .AND. Valtype( aHelp[nElement] ) = 'C'
      @ aMsgOpt[6], aMsgOpt[5]+2 SAY '[ F1=Help ]'
    ELSE
      @ aMsgOpt[6], aMsgOpt[5]+2 TO aMsgOpt[6], aMsgOpt[7]-1
    ENDIF
  ELSE
    aMsgScrn := ;
      { aMsgOpt[1], 0, aMsgOpt[1], DC_MaxCol(),;
        SaveScreen( aMsgOpt[1], 0, aMsgOpt[1], DC_MaxCol() ) }
    SetColor(cMENUCOLOR)
    @ aMsgOpt[1], aMsgOpt[2] CLEAR TO aMsgOpt[1], aMsgOpt[7]
    IF aMsgOpt[6]=-1  // Center Message
      SetColor( cMENUCOLOR )
      DevPos( aMsgOpt[1], (aMsgOpt[7]-aMsgOpt[2])/2 - ;
              (Len(aMessage[nElement])/2) + 1 )
      IF !Empty(aMessage[nElement])
        DevOut( aMessage[nElement], cMENUCOLOR )
      ENDIF
    ELSEIF aMsgOpt[2]>=0
      DevPos( aMsgOpt[1], aMsgOpt[2] )
      DevOut( PAD(' '+AllTrim(aMessage[nElement]),aMsgOpt[7]-aMsgOpt[2]-1), ;
              cMENUCOLOR )
    ENDIF
  ENDIF
  DC_DispEnd()
ENDIF
RETURN aMsgScrn

/* ----------------- */

/* -- Note: Use only the first 5 parameters.  The rest are there for
      compatability with old code.  See Documentation for explanation -- */

FUNCTION DC_MenuMain( aMainMenu, cStartVal, lPaintBar, aHotKeys, cHotKeys, ;
                      cStart, aMenus, aSubMenus, cExitKeys, lRetVal, nMenu,;
                      nCode, aMouseKeys, lSticky, aMsgOpt, lReMenu, ;
                      cHeirArchy, aAccelKeys, cMenuId )

LOCAL aColors[7], aMenuMain[47], nRow, nCol

#define cMM_TEMP       aMenuMain[1]
#define cMM_TEMPSTR    aMenuMain[2]
#define nMM_TEMPNUM    aMenuMain[3]
#define nMM_LASTITEM   aMenuMain[4]
#define nMM_ELEMENT    aMenuMain[5]
#define cMM_MENUSCRN   aMenuMain[6]
#define cMM_KEY        aMenuMain[7]
#define cMM_KEY2       aMenuMain[8]
#define nMM_NULLS      aMenuMain[9]
#define nMM_SAVEROW    aMenuMain[10]
#define nMM_SAVECOL    aMenuMain[11]
#define cMM_TYPE1      aMenuMain[12]
#define cMM_TYPE2      aMenuMain[13]
#define cMM_TYPE3      aMenuMain[14]
#define lMM_MOUSEHIT   aMenuMain[15]
#define bMM_KEYBLOCK   aMenuMain[16]
#define nMM_X          aMenuMain[17]
#define nMM_X1         aMenuMain[18]
#define nMM_X2         aMenuMain[19]
#define nMM_Y          aMenuMain[20]
#define nMM_Y1         aMenuMain[21]
#define nMM_Y2         aMenuMain[22]
#define cMM_MENUUNHOT  aMenuMain[23]
#define lMM_MOUVISIBLE aMenuMain[24]
#define nMM_INKEY      aMenuMain[25]
#define nMM_SAVESCREEN aMenuMain[26]
#define nMM_YLEN       aMenuMain[27]
#define aMM_MENUITEMS  aMenuMain[28]
#define aMM_HOTKEYS    aMenuMain[29]
#define aMM_MENUY      aMenuMain[30]
#define aMM_MESSAGES   aMenuMain[31]
#define aMM_ACCESS     aMenuMain[32]
#define aMM_MENUID     aMenuMain[33]
#define cMM_SAVESCRN2  aMenuMain[34]
#define nMM_MSGLEN     aMenuMain[35]
#define lMM_MESSAGE    aMenuMain[36]
#define nMM_MSGNUM     aMenuMain[37]
#define aMM_MSGSCRN    aMenuMain[38]
#define nMM_SUBLENGTH  aMenuMain[39]
#define nMM_HOTKEY     aMenuMain[40]
#define cMM_COLOR      aMenuMain[41]
#define cMM_TYPE       aMenuMain[42]
#define lMM_BAR        aMenuMain[43]
#define cMM_START      aMenuMain[44]
#define lMM_GRAYED     aMenuMain[45]
#define cMM_LASTKEY    aMenuMain[46]
#define cMM_CHILDID    aMenuMain[47]

IF Valtype( aMainMenu ) = 'C'
  aMainMenu := DC_DO('DC_MenuCompile(DC_MenuLoad("'+aMainMenu+'"))')
ENDIF
IF Valtype( aMainMenu ) = 'A'
  ASize(aMainMenu,19)
  IF Valtype(cStartVal)='C'
    cMM_START := cStartVal
  ELSE
    cMM_START := aMainMenu[6]
  ENDIF
  nMM_X      := aMainMenu[1]
  nMM_Y      := aMainMenu[2]
  cMM_COLOR  := aMainMenu[3]
  cMM_TYPE   := aMainMenu[4]
  lMM_BAR    := aMainMenu[5]
  aMenus     := aMainMenu[7]
  aSubMenus  := aMainMenu[8]
  cExitKeys  := aMainMenu[9]
  lRetVal    := aMainMenu[10]
  nMenu      := aMainMenu[11]
  nCode      := aMainMenu[12]
  aMouseKeys := aMainMenu[13]
  lSticky    := aMainMenu[14]
  aMsgOpt    := aMainMenu[15]
  lReMenu    := aMainMenu[16]
  cHeirArchy := aMainMenu[17]
  aAccelKeys := aMainMenu[18]
  cMenuID    := aMainMenu[19]
ELSE
  nMM_X      := aMenuMain
  nMM_Y      := cStartVal
  cMM_COLOR  := lPaintBar
  cMM_TYPE   := aHotKeys
  lMM_BAR    := cHotKeys
  cMM_START  := cStart
ENDIF
aHotKeys := {}
cHotKeys := ''
IF Valtype( aMenus ) # "A"
  RETURN ''
ENDIF
IF cHeirArchy = 'M'
  IF lParent
    lParent := .f.
    aMenuPush := aMainMenu
    RETURN ''
  ENDIF
  lParent := .t.
ENDIF
aMenuPush := nil

DO WHILE .t.

  IF Valtype(aMsgOpt)#'A'
    aMsgOpt := { SET(_SET_MESSAGE),-1,0,0,0,0,0,0,0,0,0,0 }
  ENDIF
  ASize( aMsgOpt, 12 )
  aMsgOpt[8] := IIF(Valtype(aMsgOpt[8])='N',aMsgOpt[8],0)
  aMsgOpt[9] := IIF(Valtype(aMsgOpt[9])='N',aMsgOpt[9],0)
  aMsgOpt[10] := IIF(Valtype(aMsgOpt[10])='N',aMsgOpt[10],0)
  aMsgOpt[11] := IIF(Valtype(aMsgOpt[11])='N',aMsgOpt[11],0)
  aMsgOpt[12] := IIF(Valtype(aMsgOpt[12])='N',aMsgOpt[12],0)
  cOLDCOLOR := SetColor()
  IF DC_MenuMouse()
    DC_INKEYRELE(0)
  ENDIF
  nMM_X        := IIF(Valtype(nMM_X)='N',nMM_X,0)
  nMM_Y        := IIF(Valtype(nMM_Y)='N',nMM_Y,0)
  cMM_COLOR    := IIF(Valtype(cMM_COLOR)='C',cMM_COLOR,'')
  cMM_TYPE     := IIF(Valtype(cMM_TYPE)='C',cMM_TYPE,'AAD')
  cMM_START    := IIF(Valtype(cMM_START)='C',cMM_START,'')
  lPaintBar := IIF(Valtype(lPaintBar)='L',lPaintBar,.f.)
  lRetVal      := IIF(Valtype(lRetVal)='L',lRetVal,.f.)
  lReMenu      := IIF(Valtype(lReMenu)='L',lReMenu,.f.)
  lMM_BAR      := IIF(Valtype(lMM_BAR)='L',lMM_BAR,.t.)
  nMenu        := IIF(Valtype(nMenu)='N',nMenu,0)
  aMenus       := IIF(Valtype(aMenus)='A',aMenus,{{},{},{},{},{}})
  lSticky      := IIF(Valtype(lSticky)='L',lSticky,.f.)
  cExitKeys    := CHR(K_ESC) + IIF(Valtype(cExitKeys)='C',cExitKeys,'')
  ASize(aMenus,6)
  aMenus[2]    := IIF(Valtype(aMenus[2])='A',aMenus[2],{})
  ASize(aMenus[2],Len(aMenus[1]))
  aMenus[3]    := IIF(Valtype(aMenus[3])='A',aMenus[3],{})
  lMM_MESSAGE := Len(aMenus[3])>0 .AND. Valtype(aMenus[3,1])='C'
  ASize(aMenus[3],Len(aMenus[1]))
  aMenus[4]    := IIF(Valtype(aMenus[4])='A',aMenus[4],{})
  ASize(aMenus[4],Len(aMenus[1]))
  aMenus[5]    := IIF(Valtype(aMenus[5])='A',aMenus[5],{})
  ASize(aMenus[5],Len(aMenus[1]))
  aMenus[6]    := IIF(Valtype(aMenus[6])='A',aMenus[6],{})
  ASize(aMenus[6],Len(aMenus[1]))
  aSubMenus    := IIF(Valtype(aSubMenus)='A',aSubMenus,{})
  ASize(aSubMenus,8)
  nMM_SUBLENGTH   := Len(aSubMenus[1])
  aSubMenus[2] := IIF(Valtype(aSubMenus[2])='A',aSubMenus[2],{})
  ASize(aSubMenus[2],nMM_SUBLENGTH)
  aSubMenus[3] := IIF(Valtype(aSubMenus[3])='A',aSubMenus[3],{})
  ASize(aSubMenus[3],nMM_SUBLENGTH)
  aSubMenus[4] := IIF(Valtype(aSubMenus[4])='A',aSubMenus[4],{})
  ASize(aSubMenus[4],nMM_SUBLENGTH)
  aSubMenus[5] := IIF(Valtype(aSubMenus[5])='A',aSubMenus[5],{})
  ASize(aSubMenus[5],nMM_SUBLENGTH)
  aSubMenus[6] := IIF(Valtype(aSubMenus[6])='A',aSubMenus[6],{})
  ASize(aSubMenus[6],nMM_SUBLENGTH)
  aSubMenus[7] := IIF(Valtype(aSubMenus[7])='A',aSubMenus[7],{})
  ASize(aSubMenus[7],nMM_SUBLENGTH)
  aSubMenus[8] := IIF(Valtype(aSubMenus[8])='A',aSubMenus[8],{})
  ASize(aSubMenus[8],nMM_SUBLENGTH)
  SET CURSOR off
  lMM_MOUVISIBLE := DC_MOUVISIBLE()
  SAVE SCREEN TO cScreen

  aMM_MENUITEMS := Array(Len(aMenus[1]))
  aMM_HOTKEYS   := Array(Len(aMenus[1]))
  aMM_MENUY     := Array(Len(aMenus[1]))
  aMM_MESSAGES  := Array(Len(aMenus[1]))
  aMM_ACCESS    := Array(Len(aMenus[1]))
  aMM_MENUID    := Array(Len(aMenus[1]))

  /* -- Set default colors -- */
  DO CASE
    CASE !DC_COLORMODE()
      cBOXCOLOR   := 'W/N,N/W,N,N,N/W'
      cMENUCOLOR  := 'W/N,N/W,N,N,N/W'
      cSELCOLOR   := 'N/W'
      cHOTCOLOR   := 'N/W'
      cGRAYCOLOR  := 'W/N,N/W,N,N,N/W'
    CASE Empty( cMM_COLOR )
      DC_CLRARR()
      cBOXCOLOR   := cC_POPMENF
      cMENUCOLOR  := left( cC_POPMENI, at( ",", cC_POPMENI ) - 1 )
      cHOTCOLOR   := substr( cC_POPMENI, at( ",", cC_POPMENI ) + 1 )
      cGRAYCOLOR  := cC_POPGRAY
      cSELCOLOR   := cC_POPMENS
    OTHERWISE
      cMM_TEMPSTR := cMM_COLOR
      cBOXCOLOR   := Left( cMM_TEMPSTR, At( ",", cMM_TEMPSTR ) - 1 )
      cMM_TEMPSTR := Substr( cMM_TEMPSTR, At( ",", cMM_TEMPSTR ) + 1 )
      cMENUCOLOR  := Left( cMM_TEMPSTR, At( ",", cMM_TEMPSTR ) - 1 )
      cMM_TEMPSTR := Substr( cMM_TEMPSTR, At( ",", cMM_TEMPSTR ) + 1 )
      cHOTCOLOR   := Left( cMM_TEMPSTR, At( ",", cMM_TEMPSTR ) - 1 )
      cMM_TEMPSTR := Substr( cMM_TEMPSTR, At( ",", cMM_TEMPSTR ) + 1 )
      cSELCOLOR   := Left( cMM_TEMPSTR, At( ",", cMM_TEMPSTR ) - 1 )
      cMM_TEMPSTR := Substr( cMM_TEMPSTR, At( ",", cMM_TEMPSTR ) + 1 )
      cGRAYCOLOR  := cMM_TEMPSTR
  ENDCASE

  nMM_LASTITEM    := Len( aMenus[1] )
  nMM_NULLS       := 0
  nMM_YLEN        := nMM_Y+1
  nMM_MSGLEN      := 0
  nMM_MSGNUM      := 0

  /* -- Store items and hot-keys into array elements -- */
  FOR nMM_TEMPNUM := 1 TO nMM_LASTITEM
    /* -- Get menu item -- */
    cMM_TEMPSTR := iif( valtype( aMenus[1,nMM_TEMPNUM] ) == "C",;
                aMenus[1,nMM_TEMPNUM], "" )

    /* -- Check for null menu items -- */
    IF Len( cMM_TEMPSTR ) = 0
      nMM_NULLS++
      LOOP
    ENDIF

    /* -- Store Y axis start of menu item -- */
    aMM_MENUY[ nMM_TEMPNUM - nMM_NULLS ] := nMM_YLEN
    nMM_YLEN := nMM_YLEN + Len( cMM_TEMPSTR ) + 1

    lMM_GRAYED := .f.
    IF Valtype( aMenus[4,nMM_TEMPNUM] ) = 'B'
      lMM_GRAYED := !EVAL(aMenus[4,nMM_TEMPNUM])
    ENDIF

    /* -- Check for tilde / store position of hot-key letter -- */
    DO CASE
      CASE LEFT(cMM_TEMPSTR,1)='*' .OR. lMM_GRAYED
        IF LEFT(cMM_TEMPSTR,1)='*'
          cMM_TEMPSTR := SUBSTR( cMM_TEMPSTR,2 )
        ENDIF
        aMM_HOTKEYS[ nMM_TEMPNUM - nMM_NULLS ] := 0
        nMM_YLEN--
      CASE "~" $ cMM_TEMPSTR
        aMM_HOTKEYS[ nMM_TEMPNUM - nMM_NULLS ] := at( "~", cMM_TEMPSTR )
        nMM_YLEN--
      OTHERWISE
        aMM_HOTKEYS[ nMM_TEMPNUM - nMM_NULLS ] := ;
                   Len(cMM_TEMPSTR)-Len(LTRIM(cMM_TEMPSTR))+1
    ENDCASE

     /* -- Store menu item -- */
    aMM_MENUITEMS[ nMM_TEMPNUM - nMM_NULLS ] := StrTran(cMM_TEMPSTR,"~","")

     /* -- Store message item -- */
    aMM_MESSAGES[ nMM_TEMPNUM - nMM_NULLS ] := aMenus[3,nMM_TEMPNUM]

     /* -- Store Menu ID -- */
    aMM_MENUID[ nMM_TEMPNUM - nMM_NULLS ] := aMenus[6,nMM_TEMPNUM]

     /* -- Calculate longest message length -- */
    IF lMM_MESSAGE
      nMM_MSGLEN := ;
        Max( Len( aMM_MESSAGES[ nMM_TEMPNUM-nMM_NULLS ] ), nMM_MSGLEN )
    ENDIF
  NEXT

  /* -- Determine number of valid elements (menu items) -- */
  nMM_LASTITEM -= nMM_NULLS

  cMM_TYPE1 := SUBSTR(cMM_TYPE,1,1)
  cMM_TYPE2 := SUBSTR(cMM_TYPE,2,1)
  cMM_TYPE3 := SUBSTR(cMM_TYPE,3,1)

  nMM_X1 := MAX(nMM_X-1,0)
  nMM_Y1 := MAX(IIF(cMM_TYPE2='B',0,nMM_Y-1),0)
  nMM_X2 := MIN(nMM_X+1,DC_MaxRow())
  nMM_Y2 := MIN(IIF(cMM_TYPE2='B',79,nMM_YLEN),DC_MaxCol())

  cMM_LASTKEY := ''

  DO WHILE .t.

    /* -- Display menu items (unhilited) and pad message items -- */
    DC_COLOR( cMENUCOLOR )
    @ nMM_X, IIF(cMM_TYPE2='B',0,nMM_Y) CLEAR TO nMM_X, IIF(cMM_TYPE2='B',79,nMM_YLEN-1)
    FOR nMM_TEMPNUM := 1 TO nMM_LASTITEM
      DevPos( nMM_X, aMM_MENUY[nMM_TEMPNUM] )
      DevOut( aMM_MENUITEMS[nMM_TEMPNUM], IIF(aMM_HOTKEYS[nMM_TEMPNUM]=0, ;
              cGRAYCOLOR, cMENUCOLOR ) )
      IF lMM_MESSAGE .AND. aMsgOpt[8]=0
        aMM_MESSAGES[nMM_TEMPNUM] := PadC(aMM_MESSAGES[nMM_TEMPNUM],nMM_MSGLEN)
      ENDIF
    NEXT
    cMM_MENUUNHOT := SAVESCREEN( nMM_X, nMM_Y, nMM_X, nMM_YLEN-1 )

    /* -- Paint box around menu items -- */
    DC_COLOR(cBOXCOLOR)
    DO CASE
      CASE cMM_TYPE1 = 'B'
        @ nMM_X-1, IIF(cMM_TYPE2='B',0,nMM_Y-1) TO ;
          nMM_X+1, IIF(cMM_TYPE2='B',79,nMM_YLEN)
      CASE cMM_TYPE1 = 'C'
        IF cMM_TYPE3 = 'D'
          @ nMM_X-1, IIF(cMM_TYPE2='B',0,nMM_Y-1) TO ;
            nMM_X-1, IIF(cMM_TYPE2='B',79,nMM_YLEN) DOUBLE
          @ nMM_X+1, IIF(cMM_TYPE2='B',0,nMM_Y-1) TO ;
            nMM_X+1, IIF(cMM_TYPE2='B',79,nMM_YLEN)
        ELSE
          @ nMM_X+1, IIF(cMM_TYPE2='B',0,nMM_Y-1) TO ;
            nMM_X+1, IIF(cMM_TYPE2='B',79,nMM_YLEN) DOUBLE
          @ nMM_X-1, IIF(cMM_TYPE2='B',0,nMM_Y-1) TO ;
            nMM_X-1, IIF(cMM_TYPE2='B',79,nMM_YLEN)
        ENDIF
    ENDCASE

    /* -- Hilite Hot-keys -- */
    DC_COLOR( cHOTCOLOR, .t. )
    FOR nMM_TEMPNUM := 1 TO nMM_LASTITEM
      nMM_HOTKEY := aMM_HOTKEYS[ nMM_TEMPNUM ]
      IF nMM_HOTKEY > 0
        @ nMM_X, aMM_MENUY[ nMM_TEMPNUM ] + nMM_HOTKEY -1 ;
          SAY SubStr( aMM_MENUITEMS[ nMM_TEMPNUM ], nMM_HOTKEY, 1 )

        /* -- Store Mouse Keys -- */
        AADD( aHotKeys, { nMM_X, aMM_MENUY[nMM_TEMPNUM], ;
                          nMM_X, aMM_MENUY[nMM_TEMPNUM] + ;
                          Len(TRIM(aMM_MENUITEMS[nMM_TEMPNUM])),;
                          SubStr( aMM_MENUITEMS[nMM_TEMPNUM],nMM_HOTKEY,1)} )
        cHotKeys += SubStr(aMM_MENUITEMS[nMM_TEMPNUM],nMM_HOTKEY,1)
      ENDIF
    NEXT

    nMM_INKEY := K_RIGHT
    nMM_ELEMENT := 1

    /* -- Calculate starting menu item to hilight  -- */
    IF nMenu>0
      nMM_ELEMENT := nMenu
      nMM_INKEY := K_ENTER
    ELSEIF !Empty(cMM_START)
      cMM_KEY := SubStr(cMM_START,1,1)
      FOR nMM_TEMPNUM := 1 TO nMM_LASTITEM
        IF cMM_KEY == Upper( SubStr( aMM_MENUITEMS[ nMM_TEMPNUM ],;
                         aMM_HOTKEYS[ nMM_TEMPNUM ], 1 ) )
          nMM_ELEMENT := nMM_TEMPNUM
          nMM_INKEY := K_ENTER
          EXIT
        ENDIF
      NEXT
    ELSEIF !Empty(cMenuID) .AND. ;
         !Empty(cMM_CHILDID:=DC_DO('DC_MenuID("'+cMenuID+'")',,.f.,''))
      FOR nMM_TEMPNUM := 1 TO nMM_LASTITEM
        IF cMM_CHILDID == aMM_MENUID[ nMM_TEMPNUM ]
          nMM_ELEMENT := nMM_TEMPNUM
          nMM_INKEY := K_ENTER
          EXIT
        ENDIF
      NEXT
    ENDIF

    IF lPaintBar
      RETURN ''
    ENDIF

    /* -- Save menu screen without the select bar -- */
    cMM_MENUSCRN := SaveScreen( nMM_X, nMM_Y, nMM_X, nMM_Y + nMM_YLEN )

    IF lMM_BAR
      /* -- Display select bar over starting menu item -- */
      DC_COLOR( cSELCOLOR, .t. )
      @ nMM_X, aMM_MENUY[ nMM_ELEMENT ] SAY ALLTRIM( aMM_MENUITEMS[ nMM_ELEMENT ] )
    ENDIF

    lMM_MOUSEHIT := .f.
    DC_InkeyMGet( @nRow, @nCol )

    lMenuScrn := .t.
    DO WHILE .t.

      DO WHILE aMM_HOTKEYS[ nMM_ELEMENT ] = 0
        IF nMM_INKEY=K_RIGHT
          nMM_ELEMENT++
          IF nMM_ELEMENT > nMM_LASTITEM
            nMM_ELEMENT := 1
          ENDIF
        ELSE
          nMM_ELEMENT--
          IF nMM_ELEMENT < 1
            nMM_ELEMENT := nMM_LASTITEM
          ENDIF
        ENDIF
      ENDDO
      SET CURSOR OFF
      cMM_KEY := ""
      lMM_MOUSEHIT := .f.

      IF EMPTY(cMM_START) .AND. nMenu=0

        IF lMM_BAR .AND. NextKey()=0
          /* -- Display select bar over selected menu item -- */
          RestScreen( nMM_X, nMM_Y, nMM_X, nMM_Y + nMM_YLEN, cMM_MENUSCRN )
          DC_COLOR( cSELCOLOR, .t. )
          @ nMM_X, aMM_MENUY[ nMM_ELEMENT ] SAY ;
            ALLTRIM( aMM_MENUITEMS[ nMM_ELEMENT ] )
        ENDIF

        IF lMM_MESSAGE
          nMM_MSGNUM := nMM_ELEMENT
          IF aMsgOpt[8]=2
            aMsgOpt[11] := nMM_X+1
            aMsgOpt[12] := aMM_MENUY[nMM_ELEMENT]
          ENDIF
          aMM_MSGSCRN := _DCMenuMsg( nMM_ELEMENT, aMsgOpt, aColors, ;
                         aMM_MESSAGES, ,.t.,.f. )
        ENDIF
        BEGIN SEQUENCE
        nMM_SAVECOL := nCol
        IF nMM_INKEY # K_ENTER
          nMM_INKEY := DC_INKEY(,0,@nRow,@nCol)
        ENDIF
        IF nMM_INKEY = -101 .OR. nMM_INKEY = -102
          DO CASE
            CASE !EMPTY(DC_MOUSEKEY(aMouseKeys,,,nRow,nCol))
              BREAK
            CASE nRow < nMM_X-1 .OR. nRow > nMM_X+1
              nMM_INKEY := K_ESC
              IF DC_MenuMouse()
                DC_INKEYRELE(0)
              ENDIF
              nCol := 0
              BREAK
            CASE nRow=nMM_X .AND. nCol#nMM_SAVECOL
              FOR nMM_TEMPNUM := 1 TO nMM_LASTITEM
                IF nCol >= aMM_MENUY[nMM_TEMPNUM] .AND. ;
                  nCol <= aMM_MENUY[nMM_TEMPNUM]+Len(aMM_MENUITEMS[nMM_TEMPNUM]) ;
                     .AND. aMM_HOTKEYS[nMM_TEMPNUM] > 0
                   nMM_ELEMENT := nMM_TEMPNUM
                   lMM_MOUSEHIT := .t.
                   BREAK
                ENDIF
              NEXT
          ENDCASE
        ENDIF
        END SEQUENCE
        IF lMM_MOUSEHIT
          nMM_INKEY := K_ENTER
          LOOP
        ENDIF
      ENDIF

      /* -- Store Menu ID -- */
      IF nMM_INKEY = DC_DO('DC_MenuIDKey()',,.f.,-500)
        DC_DO('DC_MenuID("'+cMenuID+'","'+aMM_MENUID[nMM_ELEMENT]+'")',,.f.,'')
        LOOP
      ENDIF

      /* -- Escape Key -- */
      IF CHR(nMM_INKEY) $ cExitKeys
        cMM_KEY := CHR(nMM_INKEY)
        lReMenu := .f.
        EXIT
      ENDIF

      /* -- Accelerator Key -- */
      IF DC_MenuAccel( aAccelKeys, nMM_INKEY )
        LOOP
      ENDIF

      /* -- Function Key -- */
      IF nMM_INKEY < 0 .AND. nMM_INKEY > -100
        cMM_KEY := '*'
        nReturn := nMM_INKEY
        lReMenu := .f.
        EXIT
      ENDIF

      /* -- Only if menu-bar is used -- */
      IF lMM_BAR
        DO CASE

          /* -- Enter Key or Double-Click -- */
          CASE nMM_INKEY == K_ENTER
            IF lMM_BAR
              IF lRetVal
                cMM_KEY := CHR( nMM_ELEMENT )
              ELSE
                cMM_KEY := ;
                Upper( Substr( aMM_MENUITEMS[ nMM_ELEMENT ], ;
                       aMM_HOTKEYS[ nMM_ELEMENT ], 1 ) )
              ENDIF
              RestScreen( nMM_X, nMM_Y, nMM_X, nMM_YLEN-1, cMM_MENUUNHOT )
              IF lMM_BAR
                /* -- Display select bar over selected menu item -- */
                DC_COLOR( cSELCOLOR, .t. )
                @ nMM_X, aMM_MENUY[ nMM_ELEMENT ] SAY ;
                  ALLTRIM( aMM_MENUITEMS[ nMM_ELEMENT ] )
              ENDIF
              aMenus[5,nMM_ELEMENT] := ;
                     IIF(Valtype(aMenus[5,nMM_ELEMENT])='C', ;
                      aMenus[5,nMM_ELEMENT],'')
              DO CASE
                CASE !DC_DO('DC_UserAccess("' + ;
                            aMenus[5,nMM_ELEMENT]+'","")',,.f.,.t.)
                 IF cMM_LASTKEY = '>'
                   KEYBOARD CHR(K_RIGHT)+CHR(K_ENTER)
                 ELSEIF cMM_LASTKEY = '<'
                   KEYBOARD CHR(K_LEFT)+CHR(K_ENTER)
                 ELSE
                   DC_MsgBox(,,{'Menu Selection Not Available'},,.t.)
                 ENDIF
                 cMM_LASTKEY := ''
                 cMM_KEY2 := ''

                CASE Valtype(aMenus[ 2, nMM_ELEMENT ])='B'
                  IF Empty(cStartVal)
                    cMM_SAVESCRN2 := SaveScreen( nMM_X1, nMM_Y1, nMM_X2, nMM_Y2 )
                    BEGIN SEQUENCE
                    Eval( aMenus[ 2, nMM_ELEMENT] )
                    END SEQUENCE
                    RestScreen( nMM_X1, nMM_Y1, nMM_X2, nMM_Y2, cMM_SAVESCRN2 )
                    IF DC_MenuMouse()
                      DC_InkeyRele(0)
                    ENDIF
                    cMM_KEY2 := '*'
                    IF lSticky
                      nMM_INKEY := 0
                      LOOP
                    ENDIF
                  ELSE
                    nMM_INKEY := 0
                    cStartVal := nil
                    LOOP
                  ENDIF

                CASE Len(aSubMenus[1])>0
                  IF Valtype( aSubMenus[1,nMM_ELEMENT] ) = 'A'
                    IF Valtype(nCode)#'N'
                      nCode := SubStr(cMM_START,2,1)
                    ENDIF
                    cMM_KEY2 := ;
                      DC_MenuPull( { nMM_X+IIF(cMM_TYPE3='D',1,0),;
                           aMM_MENUY[nMM_ELEMENT], '', ;
                           cMM_COLOR, IIF(cMM_TYPE3='D','A','B'), ;
                           lMM_BAR, lRetVal, cExitKeys,,.f., lSticky, ;
                           lReMenu, 'S', aMouseKeys, aMsgOpt, nil, ;
                           aSubMenus[1,nMM_ELEMENT], ;
                           aSubMenus[7,nMM_ELEMENT], ;
                           aSubMenus[2,nMM_ELEMENT], ;
                           aSubMenus[3,nMM_ELEMENT], ;
                           aSubMenus[4,nMM_ELEMENT], ;
                           aSubMenus[5,nMM_ELEMENT], ;
                           aSubMenus[6,nMM_ELEMENT], ;
                           aAccelKeys,;
                           aSubMenus[8,nMM_ELEMENT] },;
                           @nCode,;
                           nil,;
                           aMM_MENUID[ nMM_ELEMENT ] )[1]

                    IF cMM_KEY2 $ cExitKeys .OR. EMPTY(cMM_KEY2)
                      nMM_INKEY := 0
                      cMM_START := ''
                      nMenu := 0
                      LOOP
                    ENDIF
                  ELSEIF VALTYPE ( aSubMenus[1,nMM_ELEMENT] ) = 'B'
                    cMM_SAVESCRN2 := ;
                       SaveScreen( nMM_X1, nMM_Y1, nMM_X2, nMM_Y2 )
                    BEGIN SEQUENCE
                    cMM_KEY2 := Eval( aSubMenus[ 1, nMM_ELEMENT] )
                    END SEQUENCE
                    RestScreen( nMM_X1, nMM_Y1, nMM_X2, nMM_Y2, cMM_SAVESCRN2 )
                    IF DC_MenuMouse()
                      DC_InkeyRele(0)
                    ENDIF
                  ENDIF

                OTHERWISE
                  cMM_KEY2 := ''

              ENDCASE

              IF Valtype(cMM_KEY2)='C'
                cMM_KEY += cMM_KEY2
              ENDIF

            ENDIF
            cMM_START := ''
            nMenu := 0

           /* -- Left Arrow -- */
          CASE nMM_INKEY == K_LEFT .OR. nMM_INKEY == K_BS .OR. nMM_INKEY == 52
            IF nMM_ELEMENT == 1
              nMM_ELEMENT := nMM_LASTITEM
            ELSE
              nMM_ELEMENT--
            ENDIF
            cMM_KEY := 'x'

           /* -- Right Arrow -- */
          CASE nMM_INKEY == K_RIGHT .OR. nMM_INKEY == 54
            IF nMM_ELEMENT == nMM_LASTITEM
              nMM_ELEMENT := 1
            ELSE
              nMM_ELEMENT++
            ENDIF
            cMM_KEY := 'x'

           /* -- Home Key -- */
          CASE nMM_INKEY == K_HOME .OR. nMM_INKEY == 55
            nMM_ELEMENT := 1
            cMM_KEY := 'x'

           /* -- End Key -- */
          CASE nMM_INKEY == K_END .OR. nMM_INKEY == 49
            nMM_ELEMENT := nMM_LASTITEM
            cMM_KEY := 'x'

        ENDCASE
        nCol := 0

      ENDIF

       /* -- Check for valid hot-key pressed -- */
      IF nMM_INKEY # K_ENTER
        BEGIN SEQUENCE
        IF cMM_KEY == ""
          cMM_KEY := Upper( DC_ChrInkey( nMM_INKEY ) )
          FOR nMM_TEMPNUM := 1 TO nMM_LASTITEM
            IF cMM_KEY == Upper( SubStr( aMM_MENUITEMS[ nMM_TEMPNUM ],;
                       aMM_HOTKEYS[ nMM_TEMPNUM ], 1 ) )
              nMM_ELEMENT := nMM_TEMPNUM
              nMM_INKEY := K_ENTER
              cMM_KEY := ''
              BREAK
            ENDIF
          NEXT
        ENDIF
        cMM_KEY := ''
        END SEQUENCE
      ELSE
        nMM_INKEY := 0
      ENDIF

      IF RIGHT(cMM_KEY,1) = '>'
        KEYBOARD CHR(K_RIGHT)+CHR(K_ENTER)
        nMM_INKEY := 0
        cMM_LASTKEY := '>'
        cStartVal := 'X'
        LOOP
      ELSEIF RIGHT(cMM_KEY,1) = '<'
        KEYBOARD CHR(K_LEFT)+CHR(K_ENTER)
        nMM_INKEY := 0
        cMM_LASTKEY := '<'
        cStartVal := 'X'
        LOOP
      ENDIF
      IF Len(ALLTRIM( cMM_KEY )) >= 2
        EXIT
      ENDIF
      cMM_START :=''
      nMenu := 0

    ENDDO

    IF !lReMenu
      EXIT
    ENDIF

  ENDDO
  IF Empty(aMenuPush) .OR. Len(aMenuPush)#17
    EXIT
  ENDIF
  aMainMenu := aMenuPush
  aMenuPush := nil
  lParent := .f.

ENDDO

DC_COLOR( cOLDCOLOR )
IF lMenuScrn
  IF lMM_MESSAGE .AND. Valtype(aMM_MSGSCRN)='A' .AND. lMenuScrn
     RestScreen( aMM_MSGSCRN[1],aMM_MSGSCRN[2],aMM_MSGSCRN[3],;
                 aMM_MSGSCRN[4],aMM_MSGSCRN[5] )
  ENDIF
  DC_RestScreen(cScreen)
ENDIF
cScreen := nil
SET CURSOR on
IF nMM_INKEY#K_ESC
  nMenu := nMM_ELEMENT
ENDIF
IF lMM_MOUVISIBLE
  DC_MOUSHOW()
ENDIF
IF DC_MenuMouse()
  DC_INKEYRELE(0)
ENDIF
RETURN cMM_KEY

/* ----------------- */

FUNCTION dc_menuaccel ( aAccelKey, nAccelKey )

LOCAL nFound, aAccel

IF Valtype(aAccelKey)='A' .AND. Len(aAccelKey) > 0 .AND. ;
   Valtype(nAccelKey)='N' .AND. nAccelKey#0
  aAccel := DC_Aconvert(aAccelKey)
  nFound := ASCAN( aAccel[1], nAccelKey )
  IF nFound > 0
    IF Valtype(aAccel[2,nFound])='B'
      Eval(aAccel[2,nFound])
    ENDIF
    nReturn := 0
    IF Valtype(aAccel[3,nFound])='N'
      nReturn := aAccel[3,nFound]
    ENDIF
    RETURN .t.
  ENDIF
ENDIF
RETURN .f.

/* ----------------- */

PROCEDURE DC_MenuScrn ()
lMenuScrn := .f.
RETURN

/* ----------------- */

FUNCTION DC_at_prompt ( nRow, nCol, cPrompt, cMessage, cMenuId )

DC_Valtype( @nRow,0,  @nCol,0,  @cPrompt,'',  @cMessage,'' )
AADD( aMenuPrompt[1],{ INT(nRow), INT(nCol) } )
AADD( aMenuPrompt[2],cPrompt)
AADD( aMenuPrompt[3],cMessage)
AADD( aMenuPrompt[4],cMenuId)
@ INT(nRow), INT(nCol) SAY StrTran(cPrompt,'~','')
RETURN nil

/* ----------------- */

FUNCTION DC_AtPrompt ( nRow, nCol, cPrompt, PromptList, cMessage, ;
                       cMenuId, bBlock )

DC_Valtype( @nRow,0,  @nCol,0,  @cPrompt,'', @cMenuId,'' )
AADD( PromptList,{ INT(nRow), INT(nCol), cPrompt, cMessage, ;
                  cMenuId, bBlock } )

IF !DC_Gui()
  @ INT(nRow), INT(nCol) SAY StrTran(cPrompt,'~','')
ENDIF
RETURN nil

/* ----------------- */

FUNCTION dc_menu_to ( nStart, nMsgRow, nMsgCol, cColor, cMenuId )

LOCAL nChoice, cMenuColor, cSelColor, aReturn, cOldColor, aSavePrompt

DC_Valtype( @nMsgRow,SET(_SET_MESSAGE), ;
            @nMsgCol,IIF(SET(_SET_MCENTER),-1,0 ) )
DC_INKEYRELE(0)
cOldColor := SETCOLOR()
IF Valtype(cColor)#'C'
  cColor := SETCOLOR()
  cMenuColor := Left( cColor, at( ",", cColor ) - 1 )
  cSelColor := SubStr( cColor, at( ",", cColor ) + 1 )
  cColor := cMenuColor+','+cMenuColor+','+cMenuColor+','+cSelColor
ENDIF

aSavePrompt := ACLONE(aMenuPrompt)
DC_At_Clear()
aReturn := DC_MenuPull( { ,,, cColor, 'X', .t., .f.,,,,,,,, ;
                      { nMsgRow, nMsgCol,,,,nMsgCol,79 }, aSavePrompt[1], ;
                      aSavePrompt[2], nil,, aSavePrompt[3],,,,,;
                      aSavePrompt[4] }, @nStart, .f., cMenuID )
SETCOLOR(cOldColor)
nStart := aReturn[2]
RETURN nStart

/* ----------------- */

FUNCTION dc_at_clear()
aMenuPrompt := {{},{},{},{}}
RETURN nil

/* ----------------- */

FUNCTION dc_MenuTo( PromptList, nChoice, cVarName, cTitle, aMsgOpt, lTrim )

LOCAL i

IF DC_Gui()
  nChoice := DC_GuiMenuto( @PromptList, nChoice, cVarName, cTitle, ;
                           aMsgOpt, lTrim )
ELSE
  nChoice := _MenuTo( PromptList, nChoice, cVarName )
ENDIF
RETURN nChoice

/* ----------------- */

/* -- This function is provided for 2.5 compatability. -- */

FUNCTION dc_menu ( nStrow, nStcol, nEnrow, nEncol, cTitle,;
                   c1, c2, c3, c4, c5, c6, c7, c8, c9, c10, c11, c12,;
                   c13, c14, c15, c16, c17, c18, c19, c20, c21, c22, c23 )

MEMVAR code    /* -- Compatability -- */
LOCAL aPrompts := {}, i
aPrompts := { c1, c2, c3, c4, c5, c6, c7, c8, c9, c10, c11, c12,;
              c13, c14, c15, c16, c17, c18, c19, c20, c21, c22, c23 }
ASize( aPrompts, PCOUNT()-5)
FOR i := 1 TO Len(aPrompts)
  aPrompts[i] := aPrompts[i]
NEXT
code := DC_MENU_P( nEnrow+1, nStcol, cTitle,,'B',,,,aPrompts)
RETURN code

/* ----------------- */

FUNCTION dc_alert ( cTitle, aMenu, cColor, lJustify, aMenuId, cMenuName, ;
                    nChoice, aPos, aFonts )

LOCAL i, cSaveScrn, nCursor, nCol,  cSaveColor, nBoxWidth := 0, ;
      nMenuWidth := 0, nTitleWidth := 0, nRow, nBoxCol, nMenuCol, ;
      nTitleCol, aTitle, cBoxColor, cMenuColor, cTempStr, cDevice

DC_Valtype(  @aMenu,{'Ok'},;
             @cColor,'W+/R,W+/R,W+/R,W+/B',;
             @lJustify,.f.,;
             @aMenuId,{},;
             @cMenuName,'',;
             @nChoice,1 )

IF DC_Gui()
  RETURN DC_GuiAlert( nil, cTitle, aMenu, nil, nil, @aPos, nil, aFonts, @nChoice )
ENDIF

nCursor := SET(_SET_CURSOR,0)
cSaveColor := SETCOLOR()
cDevice := SET(_SET_DEVICE,'SCREEN')
cTempStr := cColor
cBoxColor := left( cTempStr, at( ",", cTempStr ) - 1 )
cTempStr := substr( cTempStr, at( ",", cTempStr ) + 1 )
cMenuColor := left( cTempStr, at( ",", cTempStr ) - 1 )
DC_INKEYRELE(0)
IF Valtype(cTitle) = 'A'
  aTitle := cTitle
ELSE
  cTitle := IIF(Valtype(cTitle)='C',cTitle,'')
  cTitle := StrTran( cTitle, ';', SPACE(75) )
  aTitle := DC_StrWrap( cTitle, 70 )
ENDIF
IF Len(aTitle) = 1
  aTitle[1] := Alltrim(aTitle[1])
ENDIF
FOR i := 1 TO Len(aTitle)
  nTitleWidth := MAX( nTitleWidth, Len(aTitle[i]) )
NEXT
FOR i := 1 TO Len(aMenu)
  nMenuWidth += Len(DC_XtoC(aMenu[i]))+3
NEXT
nBoxWidth := MAX( nTitleWidth, nMenuWidth )
nRow      := (DC_MaxRow()-Len(aTitle)-3)/2
nBoxCol   := (DC_MaxCol()-nBoxWidth-4)/2
nTitleCol := (DC_MaxCol()-nTitleWidth)/2
nMenuCol  := INT( (DC_MaxCol()-nMenuWidth)/2 + 1 )
cSaveScrn := DC_Explode( nRow, nBoxCol, nRow+Len(aTitle)+3, ;
             nBoxCol+nBoxWidth+3, cBoxColor, cBoxColor )
nRow += 1
ASize(aMenuId,Len(aMenu))
FOR i := 1 TO Len(aTitle)
  IF lJustify
    nCol := nBoxCol+2
  ELSE
    nCol := ( nTitleCol + nTitleWidth/2 - Len(aTitle[i])/2 )
  ENDIF
  @ nRow, nCol SAY aTitle[i]
  nRow++
NEXT
nRow++
SetColor( cMenuColor )
FOR i := 1 TO Len(aMenu)
  DC_At_Prompt( nRow, nMenuCol, DC_XtoC(aMenu[i]),, aMenuId[i] )
  nMenuCol += Len(DC_XtoC(aMenu[i]))+3
NEXT
nChoice := DC_Menu_To( nChoice, 17, -1, cColor, cMenuName )
DC_Implode( cSaveScrn )
DC_InkeyRele(0)
SET(_SET_CURSOR,nCursor)
SETCOLOR( cSaveColor )
SET(_SET_DEVICE,cDevice)
RETURN nChoice

/* --------------------------- */

FUNCTION dc_menuname ( cMenu )

STATIC cMenuName := ''
LOCAL cOldMenu := cMenuName
cMenuName := IIF(Valtype(cMenu)='C',UPPER(ALLTRIM(cMenu)),'')
RETURN cOldMenu

/* ---------------------------- */

FUNCTION dc_menureturn ( nReturnVal )

LOCAL nOldReturn := nReturn
IF Valtype(nOldReturn)#'N'
  nReturn := 0
  nOldReturn := nReturn
ENDIF
IF Valtype( nReturnVal ) = 'N'
  nReturn := nReturnVal
ENDIF
RETURN nOldReturn

/* ----------------------------- */

FUNCTION DC_MenuLock ( lMode )

STATIC lLockMode := .f.
LOCAL lOldMode := lLockMode
lLockMode := IIF(Valtype(lMode)='L',lMode,lLockMode)
RETURN lOldMode

/* ----------------------------- */

FUNCTION DC_MenuMouse ( lMode )

STATIC lMouseRele := .t.
LOCAL lOldMode := lMouseRele
lMouseRele := IIF(Valtype(lMode)='L',lMode,lMouseRele)
RETURN lOldMode

/* ----------------------------- */

FUNCTION DC_GuiMenuTo( aPrompt, nChoice, cVarName, cTitle, aMsgOpt, lTrim )

LOCAL oDlg, oXbp, mp1, mp2, nEvent, nHeight, nWidth, nStartRow,;
      nEndRow, nStartCol, nEndCol, nMsgRow, nMsgCol, oParent,;
      nCol, nRow, i, drawingArea, oMsg, nMsgWidth, cMsgFont,;
      lMsgCenter, aHotkeys := {}

IF Valtype(aPrompt) # 'A'
  RETURN nil
ENDIF
lTrim   := IIF(Valtype(lTrim)='L',lTrim,.t.)
aMsgOpt := IIF(Valtype(aMsgOpt)='A',aMsgOpt,{})
ASize(aMsgOpt,4)
aMsgOpt[1] := IIF(Valtype(aMsgOpt[1])='N',aMsgOpt[1],DC_MaxRow())
aMsgOpt[2] := IIF(Valtype(aMsgOpt[2])='N',aMsgOpt[2],0)
aMsgOpt[3] := IIF(Valtype(aMsgOpt[3])='N',aMsgOpt[3],.t.)
nMsgRow    := aMsgOpt[1]
nMsgCol    := aMsgOpt[2]
lMsgCenter := aMsgOpt[3]
cMsgFont   := IIF(Valtype(aMsgOpt[4])='C',aMsgOpt[4],'12.Times.Roman')
cTitle  := IIF(Valtype(cTitle)='C',cTitle,'')
nStartRow := DC_MaxRow()
nStartCol := DC_MaxCol()
nEndRow   := 0
nEndCol   := 0
nMsgWidth := 0

FOR i := 1 TO Len(aPrompt)
  nStartRow := Min(nStartRow,aPrompt[i,1])
  nEndRow   := Max(nEndRow,aPrompt[i,1])
  nStartCol := Min(nStartCol,aPrompt[i,2])
  nEndCol   := Max(nEndCol,aPrompt[i,2]+Len(aPrompt[i,3]))
  aPrompt[i,4] := IIF(Valtype(aPrompt[i,4])='C',aPrompt[i,4],'')
  nMsgWidth := Max(nMsgWidth,Len(aPrompt[i,4]))
  nEndCol   := Max(nEndCol,nMsgCol+Len(aPrompt[i,4]))
NEXT

IF nMsgWidth > 0
  IF Valtype(nMsgRow)#'N'
    nMsgRow := Set(_SET_MESSAGE)
    nMsgCol := 0
  ENDIF
  nStartRow := Min(nStartRow,nMsgRow)
  nEndRow   := Max(nEndRow,nMsgRow)
  nStartCol := Min(nStartCol,nMsgCol)
  nEndCol   := Max(nEndCol,nMsgCol)
ENDIF

IF !lTrim
  nWidth  := DC_MaxCol()
  nHeight := DC_MaxRow()
ELSE
  nWidth := nEndCol - nStartCol + 4
  nHeight := nEndRow - nStartRow + 4
ENDIF

nWidth  := (nWidth * 7.0)
nHeight := (nHeight * 20 )
oParent := AppDeskTop() // SetAppWindow():setParent()
nCol := (oParent:currentSize()[1]-nWidth)/2
nRow := (oParent:currentSize()[2]-nHeight)/2

oDlg := XbpDialog():new( oParent, , { nCol, nRow }, { nWidth, nHeight } )
oDlg:taskList := .T.
oDlg:title := cTitle
IF Valtype(DC_IconDefault())='N'
  oDlg:icon := DC_IconDefault()
ENDIF
oDlg:visible := .F.
oDlg:create()
drawingArea := oDlg:drawingArea

FOR i := 1 TO Len(aPrompt)

  ASize( aPrompt[i],6 )
  oXbp := XbpPushButtonEx():new( drawingArea, , ;
              { _GetCol(aPrompt[i,2], nWidth, lTrim, nStartCol ), ;
                _GetRow(aPrompt[i,1], nHeight, lTrim, nStartRow ) }, ;
              { Len(aPrompt[i,3]) * 7, 20 } )
  oXbp:caption := aPrompt[i,3]
  oXbp:clipSiblings := .T.
  oXbp:create()
  oXbp:activate := aPrompt[i,5]
  oXbp:cargo    := aPrompt[i,4]
  aPrompt[i,6] := oXbp
  AADD( aHotKeys, Upper(Left(Alltrim(aPrompt[i,3]),1)) )

NEXT

IF nMsgWidth > 0
  oMsg := XbpStatic():new( drawingArea, , ;
              { _GetCol(nMsgCol, nWidth, lTrim, nStartCol ), ;
                _GetRow(nMsgRow, nHeight, lTrim, nStartRow ) }, ;
              { IIF(Set(_SET_MCENTER),nWidth,nMsgWidth * 7), 20 } )
  oMsg:caption := aPrompt[1,4]
  oMsg:clipSiblings := .T.
  oMsg:type := XBPSTATIC_TYPE_TEXT
  IF Valtype(cMsgFont)='C'
    oMsg:SetFontCompoundName(cMsgFont)
  ENDIF
  oMsg:create()
ENDIF

oDlg:Show()
nEvent := xbe_None
SetAppFocus(aPrompt[1,6])
_ClearEvents()

IF !Empty(nChoice) .AND. Valtype(nChoice)='N'
  SetAppFocus( aPrompt[nChoice,6] )
ENDIF

DO WHILE nEvent <> xbeP_Close

  nEvent := AppEvent( @mp1, @mp2, @oXbp, 1 )
  IF (nEvent = xbeM_Motion .AND. mp1 == NIL) .OR. Valtype(oXbp)#'O'
    LOOP
  ENDIF
  oXbp:handleEvent( nEvent, mp1, mp2 )

  IF ( nEvent = xbeP_Keyboard .AND. mp1 = K_ESC)  .OR. ;
     ( nEvent = xbeP_Close )
    nChoice := 0
    EXIT
  ENDIF
  IF nEvent = xbeP_Activate .OR. nEvent = xbeP_Keyboard

    IF mp1 = xbeK_ENTER .OR. nEvent = xbeP_Activate
      FOR i := 1 TO LEN(aPrompt)
        IF oXbp == aPrompt[i,6]
          oXbp := _SetFocus( aPrompt, i, mp1 # xbeK_UP )
          IF Valtype(oMsg)='C' .AND. Valtype(oXbp:cargo) = 'C'
            oMsg:SetCaption(oXbp:cargo)
          ENDIF
          nChoice := i
          nEvent := xbeP_Close
          EXIT
        ENDIF
      NEXT
    ELSEIF ( mp1 = xbeK_UP .OR. mp1 = xbeK_DOWN )
      FOR i := 1 TO LEN(aPrompt)
        IF oXbp == aPrompt[i,6]
          oXbp := _SetFocus( aPrompt, i, mp1 # xbeK_UP )
          IF Valtype(oMsg)='C' .AND. Valtype(oXbp:cargo) = 'C'
            oMsg:SetCaption(oXbp:cargo)
          ENDIF
          _ClearEvents()
          EXIT
        ENDIF
      NEXT
    ELSEIF mp1 = xbeK_ALT_D .OR. mp1 = K_ALT_D
      DC_DO('DC_Dot()')
    ELSEIF nEvent = xbeP_Keyboard
      _ClearEvents()
      nChoice := AScan( aHotKeys, Upper(DC_ChrInkey(mp1)) )
      IF nChoice > 0
        SetAppFocus( aPrompt[nChoice,6] )
        EXIT
      ENDIF
    ENDIF
  ENDIF
  IF Valtype(oXbp:cargo)='C' .AND. Valtype(oMsg)='O'
    oMsg:SetCaption(oXbp:cargo)
  ENDIF

ENDDO

aPrompt := {}
oDlg:Destroy()
RETURN nChoice

/* ----------------------- */

STATIC FUNCTION _GetRow ( nRow, nHeight, lTrim, nStartRow )

IF lTrim
  RETURN nHeight - (nRow*20) + (nStartRow*20) - 60
ENDIF
RETURN nHeight - (nRow*20) - 20

/* ----------------------- */

STATIC FUNCTION _GetCol ( nCol, nWidth, lTrim, nStartCol )

IF lTrim
  RETURN (nCol*7) - (nStartCol*7) + 10
ENDIF
RETURN (nCol*7)

/* ----------------------------- */

STATIC FUNCTION _SetFocus ( aPrompt, i, lDown, oMsg )

LOCAL oXbp

IF lDown
  DO WHILE .t.
    IF i = LEN(aPrompt)
      IF Set(_SET_WRAP)
        i := 1
      ENDIF
    ELSE
      i++
    ENDIF
    SetAppFocus( aPrompt[i,6] )
    oXbp := aPrompt[i,6]
    EXIT
  ENDDO
ELSE
  DO WHILE .t.
    IF i = 1
      IF Set(_SET_WRAP)
        i := Len(aPrompt)
      ENDIF
    ELSE
      i--
    ENDIF
    SetAppFocus( aPrompt[i,6] )
    oXbp := aPrompt[i,6]
    EXIT
  ENDDO
ENDIF
RETURN oXbp

/* ----------------------------- */

STATIC PROCEDURE _clearevents

LOCAL nEvent := 1
DO WHILE nEvent <> 0
  nEvent := AppEvent( nil, nil, nil, .01 )
ENDDO
RETURN

/* ----------------------------- */

/*
This function works like the text mode Alert() box but for GUI applications.
It displays centered on the specified window.
*/

FUNCTION DC_GuiAlert( oOwner, cText, aCaption, nSysIcon, cTitle, aDlgPos, ;
                      lModal, aFonts, nChoice )

   LOCAL nEvent   , mp1 , mp2, oXbp , lExit
   LOCAL oParent  , oDlg, oPS, oFont, oFocus, oDesktop
   LOCAL aPushBtn , aPbSize, nPbWidth, nPbDist, nSelect
   LOCAL oIcon    , aIconSize, nCol, nRow
   LOCAL aTextSize, aText, cHotKey
   LOCAL bSelect  , bKeyboard
   LOCAL i, imax  , nPos   , aPos    , aPos1  , aSize  , nXsize, nYsize
   LOCAL nBackGroundColor, aColor, nForeGroundColor

   DEFAULT nChoice := 1

   IF Valtype(cText) = 'A'
     aText := cText
     cText := ''
     FOR i := 1 TO Len(aText)
       cText += DC_XtoC(aText[i]) + IIF(i<Len(aText),';','')
     NEXT
   ENDIF
   aText := nil

   DEFAULT oOwner   TO SetAppWindow(), ;
           cText    TO ""            , ;
           aCaption TO { DC_LangMsg(DCMSG_OK) }     , ;
           cTitle   TO " "           , ;
           lModal   TO .t.           , ;
           nSysIcon TO XBPSTATIC_SYSICON_ICONQUESTION

   oDeskTop         := AppDesktop()


  /*
   * Create the Alert dialog window
   */
   oDlg             := XbpDialog():new( oDesktop, oOwner, , { 100, 100 }, , .F. )
   oDlg:minButton   := .F.
   oDlg:maxButton   := .F.
   oDlg:taskList    := .t.
   oDlg:title       := cTitle
   IF Valtype(DC_IconDefault())='N'
     oDlg:icon := DC_IconDefault()
   ENDIF
   oDlg:border      := XBPDLG_DLGBORDER
   oDlg:close       := {|mp1,mp2,obj| obj:hide(), lExit := .T. }
   oDlg:create()

   aColor := DC_GuiAlertColor()
   IF Valtype(aColor[1])$'AN'
     ASize(aColor,2)
     IF Valtype(aColor[1]) = 'A'
       nForegroundColor := GraMakeRGBColor(aColor[1])
       nBackgroundColor := GraMakeRGBColor(aColor[2])
     ELSEIF Valtype(aColor[1]) = 'N'
       nForegroundColor := aColor[1]
       nBackgroundColor := aColor[2]
     ENDIF
   ENDIF

   DEFAULT nBackgroundColor := XBPSYSCLR_DIALOGBACKGROUND
   DEFAULT nForegroundColor := GRA_CLR_BLACK

   DEFAULT aFonts := {}
   ASize(aFonts,2)
   DEFAULT aFonts[1] := BUTTON_FONT, ;
           aFonts[2] := TEXT_FONT

   oDlg:drawingArea:SetColorBG( nBackgroundColor )
   oDlg:drawingArea:SetColorFG( nForegroundColor )
   oDlg:drawingArea:SetFontCompoundName( aFonts[1] )
   oDlg:drawingArea:paint := {|| Repaint( aText ) }
   oDlg:SetModalState( IIF( lModal, XBP_DISP_APPMODAL, XBP_DISP_MODELESS ) )

  /*
   * Create icon if requested
   */
   IF nSysIcon <> NIL
      oIcon          := XbpStatic():new( oDlg:drawingArea, , {0,0}, {30,30} )
      oIcon:caption  := nSysIcon
      oIcon:type     := XBPSTATIC_TYPE_SYSICON
      oIcon:create()
      aIconSize      := oIcon:currentSize()
   ELSE
      aIconSize      := {0,0}
   ENDIF


  /*
   * Create a presentation space with font to calculate pushbutton
   * size from font metrics
   */
   oPS    := XbpPresSpace():new():create( oDlg:drawingArea:winDevice() )
   oFont  := XbpFont():new( oPS ):create( BUTTON_FONT )
   oPS:setFont( oFont )


  /*
   * Find longest button caption
   */
   imax   := Min( MAX_BUTTONS, Len( aCaption ) )
   nPos   := 0
   nXSize := 0

   FOR i:=1 TO imax
      IF Len( DC_XtoC(aCaption[i]) ) > nXsize
         nXsize := Len( DC_XtoC(aCaption[i]) )
         nPos   := i
      ENDIF
   NEXT

  /*
   * Determine size for pushbuttons
   */
   aPbSize    := DC_GraQueryTextBox( DC_XtoC(aCaption[nPos]), aFonts[1] )

   aPbSize[1] += 20
   aPbSize[2] += 10

   nPbDist    := aPbSize[1] / nXsize
   nPbWidth   := imax * ( aPbSize[1] + nPbDist )

  /*
   * Prepare the string for display and determine display size
   */
   oFont     := XbpFont():new( oPS ):create( aFonts[2] )
   oPS:setFont( oFont )
   aTextSize := PrepareText( oPS, @aText, cText, nForeGroundColor )


  /*
   * Calculate frame size for the Alert box (XbpDialog window)
   */
   nXsize := Max( nPbWidth + 20, aTextSize[1] + 20 ) + aIconSize[1] * 1.5
   nYsize := aTextSize[2] + 2 * aPbSize[2] + 10
   oParent := AppDeskTop() // SetAppWindow():setParent()

   IF Valtype( aDlgPos ) = 'A'
      nCol := aDlgPos[1]
      nRow := aDlgPos[2]
   ELSE
      nCol := (oParent:currentSize()[1]-nXSize)/2
      nRow := (oParent:currentSize()[2]-nYSize)/2
   ENDIF

   aSize  := oDlg:calcFrameRect( { 0, 0, nXsize, nYsize } )

   oDlg:setSize( { aSize[3], aSize[4] } )
   IF Valtype( aDlgPos ) = 'A'
      nCol := aDlgPos[1]
      nRow := aDlgPos[2]
   ENDIF
   oDlg:setPos( { nCol, nRow } )
   aDlgPos := { nCol, nRow }
   aSize := oDlg:drawingArea:currentSize()

   IF nSysIcon == NIL
     /*
      * No icon - Center text in window
      */
      aPos := CenterPos( aTextSize, aSize )
   ELSE
     /*
      * With icon - Align text next to icon
      */
      aPos    := { 0, 0 }
      aPos[1] := 1.75 * aIconSize[1]
   ENDIF
   aPos[2]    := 2.25 * aPbSize[2]
   AdjustPos( aPos, aTextSize, aText, nSysIcon )


  /*
   * Position the icon to the upper left of the text
   */
   IF oIcon <> NIL
      aPos[1] := aIconSize[1] / 3
      aPos[2] := aSize[2] - 1.5 * aIconSize[2]
      oIcon:setPos( aPos )
   ENDIF


   IF nSysIcon == NIL
     /*
      * No icon - Center pushbutton in window
      */
      aPos    := CenterPos( {nPbWidth, 2 * aPbSize[2]}, aSize )
      aPos[1] += ( nPbDist / 2 )

   ELSEIF nPbWidth < aTextSize[1]
     /*
      * Width of all pushbuttons is less than text width.
      * Center pushbutton below text
      */
      aPos    := CenterPos( {nPbWidth, 2 * aPbSize[2]}, aTextSize )
      aPos[1] += ( 1.5 * aIconSize[1] + ( nPbDist / 2 ) )

   ELSE
     /*
      * Align pushbuttons with text
      */
      aPos[1] := 1.75 * aIconSize[1]
   ENDIF


   aPushBtn   := Array( imax )
   aPos[2]    := aPbSize[2] / 2
   nSelect    := 0
   bSelect    := {|mp1 ,mp2,obj| nSelect := obj:cargo, lExit := .T. }
   bKeyBoard  := {|nKey,mp2,obj| KeyHandler( nKey, obj, aPushBtn ) }


  /*
   * Create the pushbuttons
   */
   FOR i:=1 TO imax
      aPushBtn[i] := XbpPushButtonEx():new( oDlg:drawingArea,, aPos, aPbSize )
      aPushBtn[i]:caption  := DC_XtoC(aCaption[i])
      aPushBtn[i]:cargo    := i
      aPushBtn[i]:tabstop  := .T.
      aPushBtn[i]:activate := bSelect
      aPushBtn[i]:keyboard := bKeyboard

      IF imax > 1
         IF i == 1
            aPushBtn[i]:group := XBP_BEGIN_GROUP
         ELSEIF i == imax
            aPushBtn[i]:group := XBP_END_GROUP
         ELSE
            aPushBtn[i]:group := XBP_WITHIN_GROUP
         ENDIF
      ENDIF

      aPushBtn[i]:create()
      aPos[1] += ( aPbSize[1] + nPbDist )
   NEXT


   oDlg:setModalState( XBP_DISP_APPMODAL )
   DC_CenterObject(oDlg,oOwner)
   oDlg:show()
   oFocus := SetAppFocus( aPushBtn[nChoice] )

   lExit := .F.
   BEGIN SEQUENCE
   DO WHILE !lExit
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      IF nEvent = xbeP_Keyboard
        IF mp1 == DC_DotHotKey()
          DllLoad('DCLIP1.DLL')
          &('DC_Dot()')
          LOOP
        ENDIF
        FOR i := 1 TO Len(aCaption)
          cHotKey := Substr(DC_XtoC(aCaption[i]),AT('~',DC_XtoC(aCaption[i]))+1,1)
          IF mp1 = Asc(Upper(cHotKey)) .OR. mp1 = Asc(Lower(cHotKey)) ;
               .OR. mp1 == _CharToAltKey(cHotKey)
            nSelect := i
            BREAK
          ENDIF
        NEXT
      ENDIF
      IF (nEvent = xbeM_Motion .AND. mp1 == NIL) .OR. !Valtype(oXbp)=='O'
         LOOP
      ENDIF
      oXbp:handleEvent( nEvent, mp1, mp2 )
   ENDDO
   END SEQUENCE

  /*
   * Cleanup: Reset modality, release graphical segment,
   *          dialog and set focus back.
   */
   oDlg:setModalState( XBP_DISP_MODELESS )
   GraSegDestroy( oPS, aText[2] )
   aDlgPos := oDlg:currentPos()
   oDlg:destroy()
// SetAppFocus( oFocus )
// DC_CompleteEvents()

RETURN nSelect

* ---------------

FUNCTION _CharToAltKey( cChar )

RETURN xbeK_ALT_A + Asc(Upper(cChar)) - Asc('A')


/*
 * Key handling for pushbuttons in alert box
 * The array containing the pushbuttons is not used here
 * (but may be useful for others...)
 */
STATIC PROCEDURE KeyHandler( nKey, oButton, aPushButtons )

   DO CASE
   CASE nKey == xbeK_ESC
      PostAppEvent( xbeP_Close,,, oButton:setParent():setParent() )
   CASE nKey == xbeK_RETURN
      PostAppEvent( xbeP_Activate,,, oButton )
   ENDCASE

RETURN



/*
 * Calculate entire display area for text to be displayed
 */
STATIC FUNCTION PrepareText( oPS, aText, cText, nForeGroundColor )
   LOCAL aAttr, aTextBox, nMaxWidth, nMaxHeight, cLine, aLine

   aText         := {}
   nMaxWidth     := 0
   nMaxHeight    := 0
   aAttr         := Array( GRA_AS_COUNT )

   aAttr[ GRA_AS_COLOR ] := nForeGroundColor
   oPS:setAttrString( aAttr )

   DO WHILE ! Empty( cText )
      cLine      := CutStr( ";", @cText )
      IF Empty( cLine )
         cLine   := " "
      ENDIF
      aLine      := { {0,0}, cLine, 0, 0 }
      aTextBox   := GraQueryTextBox( oPS, aLine[2] )
      aLine[3]   := aTextBox[3,1] - aTextBox[2,1]  // width of substring
      aLine[4]   := aTextBox[3,2] - aTextBox[2,2]  // height of substring
      nMaxWidth  := Max( nMaxWidth, aLine[3] )
      nMaxHeight += ( 2 + aLine[4] )
      AAdd( aText, aLine )
   ENDDO

   aText         := { oPS, 0, aText, aAttr }

RETURN { nMaxWidth, nMaxheight }



/*
 * Adjust GraStringAt() positions for centered display or left alignment
 */
STATIC PROCEDURE AdjustPos( aPos, aSize, aText, nSysIcon )
   LOCAL aLines  := aText[3]
   LOCAL i, imax := Len( aLines )

   IF nSysIcon == NIL
     /*
      * No Icon - Display text centered
      */
      FOR i := 1 TO imax
         aLines[i,1,1] := aPos[1] + ( (aSize[1] - aLines[i,3]) / 2 )
         aLines[i,1,2] := aPos[2] + aSize[2] - i * ( 2 + aLines[i,4] )
      NEXT
   ELSE
     /*
      * With Icon - Display text left aligned
      */
      FOR i := 1 TO imax
         aLines[i,1,1] := aPos[1]
         aLines[i,1,2] := aPos[2] + aSize[2] - i * ( 2 + aLines[i,4] )
      NEXT
   ENDIF
RETURN



/*
 * Repaint text using a graphical segment
 */
STATIC PROCEDURE Repaint( aText )
   LOCAL oPS    := aText[1]
   LOCAL nID    := aText[2]
   LOCAL aLines := aText[3]
   LOCAL aAttr  := aText[4]

  oPS:setAttrString( aAttr )

   IF nID == 0
      nID := GraSegOpen( oPS )
      AEval( aLines, {|a| GraStringAt( oPS, a[1], a[2] ) } )
      GraSegClose( oPS )
      aText[2] := nID
   ENDIF

   GraSegDraw( oPS, nID )

RETURN

/*
 * Calculate the center position from size and reference size
 */
STATIC FUNCTION CenterPos( aSize, aRefSize )
RETURN { Int( (aRefSize[1] - aSize[1]) / 2 ) ;
       , Int( (aRefSize[2] - aSize[2]) / 2 ) }



/*
 * Cut a string at a given delimiter and remove delimiter from string
 */
STATIC FUNCTION CutStr( cCut, cString )


   LOCAL cLeftPart, i := At( cCut, cString )

   IF i > 0
      cLeftPart := Left( cString, i-1 )
      cString   := SubStr( cString, i+Len(cCut) )
   ELSE
      cLeftPart := cString
      cString   := ""
   ENDIF

RETURN cLeftPart

* ----------------------

FUNCTION DC_GuiAlertColor( aColor )

STATIC saColor := { nil, nil, nil }
LOCAL aOldColor := saColor
IF Valtype(aColor) = 'A'
  saColor := AClone(aColor)
ENDIF

RETURN aOldColor

/*
acText := 'Please Help Me'
aCaption := {'this','is a whole lotta','testing'}
oOwner := nil
nSysIcon := nil
cTitle := 'TEsting'
aDlgPos := nil
lModal := .f.
aFonts := {'14.Arial Bold','14.Arial Black'}


nChoice := DC_GuiAlert( oOwner, acText, ;
             aCaption, ;
             nSysIcon, ;
             cTitle, ;
             aDlgPos, ;
             lModal, ;
             aFonts  )

dcqdebug nChoice
*/
